<?php
namespace Teknisa\EST\Modules\Relatorios\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DataSource\FilterCriteria;

class Est31100PosicaoDeEstoqueDia extends \Zeedhi\Framework\Controller\Report{
    protected $reportService;
    protected $dataSourceManager;
    protected $nrorg;
    protected $birtStrategy;
    protected $reportMapping = array (
       'EST31100' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        "CDFILIAL" => "P_CDFILIAL",
                        "CDALMOXARIFE" => "P_CDALMOXARIFE",
                        "CDLOCALESTOQ" => "P_CDLOCALESTOQ",
                        "DATAPOS" => "P_DTPOSIESTQ",
                        "CDTIPOCUSTO" => "P_CDTIPOCUSTO",
                        "CDARVPRODINI" => "P_CDARVPRODINI",
                        "CDARVPRODFIN" => "P_CDARVPRODFIN",
                        "NVTOT" => "P_NVTOT",
                        "ORDENANOME" => "P_ORDENANOME",
                        "NRORG" => "P_NRORG",
                        "NRTPARVPROD" => "P_NRTPARVPROD",
                        "NRARVOREPROD" => "P_NRARVOREPROD"
                    )
            ),
        'EST31100PZ' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        "CDFILIAL" => "P_CDFILIAL",
                        "CDALMOXARIFE" => "P_CDALMOXARIFE",
                        "CDLOCALESTOQ" => "P_CDLOCALESTOQ",
                        "DATAPOS" => "P_DTPOSIESTQ",
                        "CDTIPOCUSTO" => "P_CDTIPOCUSTO",
                        "CDARVPRODINI" => "P_CDARVPRODINI",
                        "CDARVPRODFIN" => "P_CDARVPRODFIN",
                        "NVTOT" => "P_NVTOT",
                        "ORDENANOME" => "P_ORDENANOME",
                        "NRORG" => "P_NRORG",
                        "NRTPARVPROD" => "P_NRTPARVPROD",
                        "NRARVOREPROD" => "P_NRARVOREPROD"
                    )
            ),
        'EST31119' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        "CDFILIAL" => "P_CDFILIAL",
                        "CDALMOXARIFE" => "P_CDALMOXARIFE",
                        "CDLOCALESTOQ" => "P_CDLOCALESTOQ",
                        "DATAPOS" => "P_DTPOSIESTQ",
                        "CDTIPOCUSTO" => "P_CDTIPOCUSTO",
                        "CDARVPRODINI" => "P_CDARVPRODINI",
                        "CDARVPRODFIN" => "P_CDARVPRODFIN",
                        "NVTOT" => "P_NVTOT",
                        "ORDENANOME" => "P_ORDENANOME",
                        "NRORG" => "P_NRORG",
                        "NRTPARVPROD" => "P_NRTPARVPROD",
                        "NRARVOREPROD" => "P_NRARVOREPROD"
                    )
            ),
        'EST32800' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        "CDFILIAL" => "P_CDFILIAL",
                        "DATAPOS" => "P_DTPOSIESTQ",
                        "CDTIPOCUSTO" => "P_CDTIPOCUSTO",
                        "CDARVPRODINI" => "P_CDARVPRODINI",
                        "CDARVPRODFIN" => "P_CDARVPRODFIN",
                        "NVTOT" => "P_NVTOT",
                        "ORDENANOME" => "P_ORDENANOME",
                        "NRORG" => "P_NRORG"
                    )
            ),
        'EST32802' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        "CDFILIAL" => "CDFILIAL",
                        "DATAPOS" => "DATAPOS",
                        "CDTIPOCUSTO" => "CDTIPOCUSTO",
                        "CDARVPRODINI" => "PRODINI",
                        "CDARVPRODFIN" => "PRODFIM",
                        "NVTOT" => "NVTOT",
                        "ORDENANOME" => "ORDENANOME",
                        "NRORG" => "P_NRORG"
                    )
            ),
        'EST32804' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        "CDGRUPFILI" => "P_CDGRUPFILI",
                        "DATAPOS" => "P_DTPOSIESTQ",
                        "DTPOSICAO" => "P_DTCUSTPROD",
                        "CDTIPOCUSTO" => "P_CDTIPOCUSTO",
                        "CDARVPRODINI" => "P_CDARVPRODINI",
                        "CDARVPRODFIN" => "P_CDARVPRODFIN",
                        "NVTOT" => "P_NVTOT",
                        "ORDENANOME" => "P_ORDENANOME",
                        "NRORG" => "P_NRORG"
                    )
            ),    
        'EST32808' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        "CDGRUPFILI" => "P_CDGRUPFILI",
                        "DATAPOS" => "P_DTPOSIESTQ",
                        "DTPOSICAO" => "P_DTCUSTPROD",
                        "CDTIPOCUSTO" => "P_CDTIPOCUSTO",
                        "CDARVPRODINI" => "P_CDARVPRODINI",
                        "CDARVPRODFIN" => "P_CDARVPRODFIN",
                        "NVTOT" => "P_NVTOT",
                        "ORDENANOME" => "P_ORDENANOME",
                        "NRORG" => "P_NRORG"
                    )
            ),    
        'EST31104' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        "CDFILIAL" => "P_CDFILIAL",
                        "CDALMOXARIFE" => "P_CDALMOXARIFE",
                        "CDLOCALESTOQ" => "P_CDLOCALESTOQ",
                        "DATAPOS" => "P_DTPOSIESTQ",
                        "CDTIPOCUSTO" => "P_CDTIPOCUSTO",
                        "CDARVPRODINI" => "P_CDARVPRODINI",
                        "CDARVPRODFIN" => "P_CDARVPRODFIN",
                        "NVTOT" => "P_NVTOT",
                        "ORDENANOME" => "P_ORDENANOME",
                        "NRORG" => "P_NRORG",
                        "NRTPARVPROD" => "P_NRTPARVPROD",
                        "NRARVOREPROD" => "P_NRARVOREPROD"
                    )
            ),
        'EST31100CODEBAR' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        "CDFILIAL" => "P_CDFILIAL",
                        "CDALMOXARIFE" => "P_CDALMOXARIFE",
                        "CDLOCALESTOQ" => "P_CDLOCALESTOQ",
                        "DATAPOS" => "P_DTPOSIESTQ",
                        "CDTIPOCUSTO" => "P_CDTIPOCUSTO",
                        "CDARVPRODINI" => "P_CDARVPRODINI",
                        "CDARVPRODFIN" => "P_CDARVPRODFIN",
                        "NVTOT" => "P_NVTOT",
                        "ORDENANOME" => "P_ORDENANOME",
                        "NRORG" => "P_NRORG",
                        "NRTPARVPROD" => "P_NRTPARVPROD",
                        "NRARVOREPROD" => "P_NRARVOREPROD"
                    )
            ),    
        'EST31100_noHeader' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        "CDFILIAL" => "P_CDFILIAL",
                        "CDALMOXARIFE" => "P_CDALMOXARIFE",
                        "CDLOCALESTOQ" => "P_CDLOCALESTOQ",
                        "DATAPOS" => "P_DTPOSIESTQ",
                        "CDTIPOCUSTO" => "P_CDTIPOCUSTO",
                        "CDARVPRODINI" => "P_CDARVPRODINI",
                        "CDARVPRODFIN" => "P_CDARVPRODFIN",
                        "NVTOT" => "P_NVTOT",
                        "ORDENANOME" => "P_ORDENANOME",
                        "NRORG" => "P_NRORG",
                        "NRTPARVPROD" => "P_NRTPARVPROD",
                        "NRARVOREPROD" => "P_NRARVOREPROD"
                    )
            ),
        'EST31120' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        "CDFILIAL" => "P_CDFILIAL",
                        "CDALMOXARIFE" => "P_CDALMOXARIFE",
                        "CDLOCALESTOQ" => "P_CDLOCALESTOQ",
                        "DATAPOS" => "P_DTPOSIESTQ",
                        "CDTIPOCUSTO" => "P_CDTIPOCUSTO",
                        "CDARVPRODINI" => "P_CDARVPRODINI",
                        "CDARVPRODFIN" => "P_CDARVPRODFIN",
                        "NVTOT" => "P_NVTOT",
                        "ORDENANOME" => "P_ORDENANOME",
                        "NRORG" => "P_NRORG",
                        "NRTPARVPROD" => "P_NRTPARVPROD",
                        "NRARVOREPROD" => "P_NRARVOREPROD"
                    )
            ),
        'EST31125' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        "CDFILIAL" => "P_CDFILIAL",
                        "CDALMOXARIFE" => "P_CDALMOXARIFE",
                        "CDLOCALESTOQ" => "P_CDLOCALESTOQ",
                        "DATAPOS" => "P_DTPOSIESTQ",
                        "CDTIPOCUSTO" => "P_CDTIPOCUSTO",
                        "CDARVPRODINI" => "P_CDARVPRODINI",
                        "CDARVPRODFIN" => "P_CDARVPRODFIN",
                        "NVTOT" => "P_NVTOT",
                        "ORDENANOME" => "P_ORDENANOME",
                        "NRORG" => "P_NRORG",
                        "NRTPARVPROD" => "P_NRTPARVPROD",
                        "NRARVOREPROD" => "P_NRARVOREPROD"
                    )
            ),
        'EST32807' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        "CDFILIAL" => "P_CDFILIAL",
                        "CDALMOXARIFE" => "P_CDALMOXARIFE",
                        "CDLOCALESTOQ" => "P_CDLOCALESTOQ",
                        "DATAPOS" => "P_DTPOSIESTQ",
                        "CDTIPOCUSTO" => "P_CDTIPOCUSTO",
                        "CDARVPRODINI" => "P_CDARVPRODINI",
                        "CDARVPRODFIN" => "P_CDARVPRODFIN",
                        "NVTOT" => "P_NVTOT",
                        "ORDENANOME" => "P_ORDENANOME",
                        "NRORG" => "P_NRORG",
                        "NRTPARVPROD" => "P_NRTPARVPROD",
                        "NRARVOREPROD" => "P_NRARVOREPROD"
                    )
            )
    );

    public function __construct(ReportService $reportService, $dataSourceManager, $environment, $birtStrategy) {
        $this->reportService       = $reportService;
        $this->dataSourceManager   = $dataSourceManager;
        $this->nrorg = $environment->getNrorgTrab();
        $this->birtStrategy        = $birtStrategy;
    }
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        
        $row['NRORG'] = $this->nrorg;
        
        $reportName = $row['NMRELATORIO'];
        $reportStrategy = $this->getReportStrategyReport($reportName);
        $parametersRow = array();
        
       
        
        foreach ($reportStrategy['parameterMapping'] as $fieldName => $paramName) {
            if ($row->has($fieldName)) {
                //Array of reports that fields need to be managed
                $ManageFieldsReports = ['EST31119','EST32800','EST32804','EST32808','EST32802'];
                
                
                
                if(in_array($reportName,$ManageFieldsReports))  {
                    switch($fieldName){
                        case 'NVTOT':
                            $parametersRow[$paramName] = $this->getNvTot($row->get($fieldName));
                            $row[$paramName] = $this->getNvTot($row->get($fieldName));
                            break;
                        case 'ORDENANOME':
                            $parametersRow[$paramName]  = ($row->get($fieldName) == 'S') ? 'N' : 'S';
                            $row[$paramName]  = ($row->get($fieldName) == 'S') ? 'N' : 'S';
                            break;
                        case 'CDALMOXARIFE':
                        case 'CDLOCALESTOQ':
                            $parametersRow[$paramName] = ($row->get($fieldName) == ' ') ? '' : $row->get($fieldName);
                            $row[$paramName] = ($row->get($fieldName) == ' ') ? '' : $row->get($fieldName);
                            break;
                        case 'DATAPOS':
                            $data = str_replace('/', '-', $row->get($fieldName));
                            $data = $reportName == 'EST31119' ? date('m/d/Y', strtotime($data)) : date('d/m/Y', strtotime($data));
                            
                            $parametersRow[$paramName] = $data;
                            $row[$paramName] = $data;
                            
                            if($reportName === 'EST32804'  || $reportName === 'EST32808' ) {
                                $parametersRow['P_DTCUSTPROD'] = $data; 
                                $row['P_DTCUSTPROD'] = $data; 
                                $parametersRow['P_CDGRUPFILI'] = $row->get('CDGRUPFILI');
                                $row['P_CDGRUPFILI'] = $row->get('CDGRUPFILI');
                            }
                            break;
                        default:
                            $parametersRow[$paramName] = $row->get($fieldName);
                            $row[$paramName] = $row->get($fieldName);
                            break;
                    }
                    
                    // ******* Refactored Code *******
                    
                    /*if($fieldName === 'NVTOT') {
                        $parametersRow[$paramName] = $this->getNvTot($row->get($fieldName));
                    }
                    else if($fieldName === 'ORDENANOME')  $parametersRow[$paramName]  = ($row->get($fieldName) == 'S') ? '0' : '10';
                    else if($fieldName === 'CDALMOXARIFE') $parametersRow[$paramName] = ($row->get($fieldName) == ' ') ? '' : $row->get($fieldName);
                    else if($fieldName === 'CDLOCALESTOQ') $parametersRow[$paramName] = ($row->get($fieldName) == ' ') ? '' : $row->get($fieldName);
                    else if($fieldName === 'DATAPOS')     {
                        $data = str_replace('/', '-', $row->get($fieldName));
                        if($reportName == 'EST31119') {
                            $data = date('m/d/Y', strtotime($data));
                        }
                        else {
                            $data = date('d/m/Y', strtotime($data));
                        }
                        $parametersRow[$paramName] = $data;
                        if($reportName === 'EST32804'  || $reportName === 'EST32808' ) {
                            $parametersRow['P_DTCUSTPROD'] = $data; 
                            $parametersRow['P_CDGRUPFILI'] = $row->get('CDGRUPFILI');
                        }
                    }
                    else $parametersRow[$paramName] = $row->get($fieldName);
                    */
                }
                else {
                    $parametersRow[$paramName] = $row->get($fieldName);
                    $row[$paramName] = $row->get($fieldName);
                }
            }
        }
        $parametersRow['P_NRORG'] = $this->nrorg;
        $row['P_NRORG'] = $this->nrorg;
        $parametersRow['__format'] = $row["__FORMAT"];
        $row['__format'] = $row["__FORMAT"];
        $this->birtStrategy->setReportFormat($row['__FORMAT']);
        
        
        $birtURL = $this->reportService->createRemoteReport('BIRT', $reportName, $parametersRow);
        $birtLink = $this->reportService->createRemoteReport('BIRT', $reportName, $parametersRow, true);
        
        $response->addMessage(new DTO\Response\Message($birtURL));
        $response->addMessage(new DTO\Response\Message($birtLink)); 
        
        /*$birtLink = $this->reportService->createRemoteReport('BIRT', $reportName, $parametersRow, true);
        $response->addMessage(new DTO\Response\Message($birtLink));
       
        
        $birtURL = $this->reportService->createRemoteReport('BIRT', $reportName, $parametersRow);
        $birtLink = $this->reportService->createRemoteReport('BIRT', $reportName, $parametersRow, true);
        
        $response->addMessage(new DTO\Response\Message($birtLink)); 
        $response->addMessage(new DTO\Response\Message($birtURL));*/
    }

    private function getNvTot($nivelEscolhido) {
        $nivelEscolhido  = $nivelEscolhido - 1;
        $filterCriteria  = new FilterCriteria('paramgeral',array());
        $dataSet         = $this->dataSourceManager->findBy($filterCriteria);
        $mascaraProdutos = $dataSet->getRows()[0]['CDPICTPROD'];
        $arrayMascara    = explode(".", $mascaraProdutos);
        for($count = 0, $nvTot = 0; $count <= $nivelEscolhido; $count++) {
            $nvTot += strlen($arrayMascara[$count]);
        }
        return $nvTot;
    }

    private function getReportStrategyReport($reportName) {
        $reportStrategy = array (
            'strategy' => 'BIRT'
        );
        switch($reportName) {
            case 'EST31100':
            case 'EST31120':
            case 'EST31125':
            case 'EST31100_noHeader':
            case 'EST32807':
            case 'EST31100PZ':
                $reportStrategy['parameterMapping'] = array (
                    "CDFILIAL" => "P_CDFILIAL",
                    "CDALMOXARIFE" => "P_CDALMOXARIFE",
                    "CDLOCALESTOQ" => "P_CDLOCALESTOQ",
                    "DATAPOS" => "P_DTPOSIESTQ",
                    "CDTIPOCUSTO" => "P_CDTIPOCUSTO",
                    "CDARVPRODINI" => "P_CDARVPRODINI",
                    "CDARVPRODFIN" => "P_CDARVPRODFIN",
                    "NVTOT" => "P_NVTOT",
                    "ORDENANOME" => "P_ORDENANOME",
                    "NRORG" => "P_NRORG",
                    "NRTPARVPROD" => "P_NRTPARVPROD",
                    "NRARVOREPROD" => "P_NRARVOREPROD"
                );
                break;
            case 'EST31119':
                $reportStrategy['parameterMapping'] = array (
                    "CDFILIAL" => "P_CDFILIAL",
                    "CDALMOXARIFE" => "P_CDALMOXARIFE",
                    "CDLOCALESTOQ" => "P_CDLOCALESTOQ",
                    "DATAPOS" => "P_DTPOSIESTQ",
                    "CDTIPOCUSTO" => "P_CDTIPOCUSTO",
                    "CDARVPRODINI" => "P_CDARVPRODINI",
                    "CDARVPRODFIN" => "P_CDARVPRODFIN",
                    "NVTOT" => "P_NVTOT",
                    "ORDENANOME" => "P_ORDENANOME",
                    "NRORG" => "P_NRORG"
                );
                break;
            case 'EST32800':
                $reportStrategy['parameterMapping'] = array (
                    "CDFILIAL" => "P_CDFILIAL",
                    "DATAPOS" => "P_DTPOSIESTQ",
                    "CDTIPOCUSTO" => "P_CDTIPOCUSTO",
                    "CDARVPRODINI" => "P_CDARVPRODINI",
                    "CDARVPRODFIN" => "P_CDARVPRODFIN",
                    "NVTOT" => "P_NVTOT",
                    "ORDENANOME" => "P_ORDENANOME",
                    "NRORG" => "P_NRORG"
                );
                break;
            case 'EST32802':
                $reportStrategy['parameterMapping'] = array (
                    "CDFILIAL" => "CDFILIAL",
                    "DATAPOS" => "DATAPOS",
                    "CDTIPOCUSTO" => "CDTIPOCUSTO",
                    "CDARVPRODINI" => "PRODINI",
                    "CDARVPRODFIN" => "PRODFIM",
                    "NVTOT" => "NVTOT",
                    "ORDENANOME" => "ORDENANOME"
                );
                break;
            case 'EST32804':
            case 'EST32808':
                $reportStrategy['parameterMapping'] = array (
                    "CDGRUPFILI" => "P_CDGRUPFILI",
                    "DATAPOS" => "P_DTPOSIESTQ",
                    "CDTIPOCUSTO" => "P_CDTIPOCUSTO",
                    "CDARVPRODINI" => "P_CDARVPRODINI",
                    "CDARVPRODFIN" => "P_CDARVPRODFIN",
                    "NVTOT" => "P_NVTOT",
                    "ORDENANOME" => "P_ORDENANOME",
                    "NRORG" => "P_NRORG"
                );
                break;
        }
        return $reportStrategy;
    }
}