<?php

namespace Teknisa\EST\Modules\Relatorios\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\Report\ReportService;


class Est32100EvolucaoDeCustoController extends \Zeedhi\Framework\Controller\Report{
    protected $reportService;
    protected $environment;
    protected $birtStrategy;
    protected $reportMapping = array (
        'Est32100EvolCust' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        "CDFILIAL"     => "P_CDFILIAL",
                        "DTPERINI"     => "P_DTINICIAL",
                        "DTPERFIN"     => "P_DTFINAL",
                        "CDARVPRODINI"    => "P_CDPRODINI",
                        "CDARVPRODFIN"    => "P_CDPRODFIN",
                        "NRORG"        => "P_NRORG",
                        "PERMINIMO"    => "P_PERMINIMO"
                    )
            )
    );

    public function __construct($environment, ReportService $reportService, $birtStrategy) {
        $this->environment   = $environment;
        $this->reportService = $reportService;
        $this->birtStrategy = $birtStrategy;
    }

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $nrorg = $this->environment->getNrOrgTrab();
        $reportStrategy = array (
            'strategy' => 'BIRT',
            'parameterMapping' => array (
                "CDFILIAL"     => "P_CDFILIAL",
                "DTPERINI"     => "P_DTINICIAL",
                "DTPERFIN"     => "P_DTFINAL",
                "CDARVPRODINI"    => "P_CDPRODINI",
                "CDARVPRODFIN"    => "P_CDPRODFIN",
                "PERMINIMO"    => "P_PERMINIMO",
                "NRORG"        => "P_NRORG"
            )
        );
        
        
        
        if($row['PERMINIMO'] == '')
            $row['PERMINIMO'] = 0;
        
        $parametersRow = array();

        foreach ($reportStrategy['parameterMapping'] as $fieldName => $paramName) {
            
            if ($row->has($fieldName)){
                $parametersRow[$paramName] = $row->get($fieldName);
                $row[$paramName] = $row->get($fieldName);
            } 
        }
        
        $parametersRow['P_NRORG'] = $nrorg;
        $row['P_NRORG'] = $nrorg;
        $parametersRow['__format'] = $row['__FORMAT'];
        $row["NRORG"] = $parametersRow['P_NRORG'] = $nrorg;
        $row['__format'] = $row['__FORMAT'];
        $this->birtStrategy->setReportFormat($row['__FORMAT']);
        $reportName = 'Est32100EvolCust';//$row['REPORT_NAME'];
        
        
        $birtURL = $this->reportService->createRemoteReport('BIRT', $reportName, $parametersRow);
        $birtLink = $this->reportService->createRemoteReport('BIRT', $reportName, $parametersRow, true);
        
        $response->addMessage(new DTO\Response\Message($birtURL));
        $response->addMessage(new DTO\Response\Message($birtLink));
        
        /*
        $birtFile = $this->reportService->createRemoteReport('BIRT', $reportName, $parametersRow);
        $birtUrl = $this->reportService->createRemoteReport('BIRT', $reportName, $parametersRow, true);
        
        $response->addMessage(new DTO\Response\Message($birtUrl));
        $response->addMessage(new DTO\Response\Message($birtFile));*/
    }
}