<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace Folha\Logic\Comite;

/**
 * Description of Reuniao
 *
 * @author phillipesilva
 */

use Geral\Entities\Operador;
use Folha\Entities\Gpetipocomite;
use Folha\Entities\GpeReuniaoitem;
use Folha\Entities\GpeReuniaoparticip;
use Folha\Entities\Gpetipocomitetiporeuniao;

class Reuniao {
    public static function retornaNrParcNegocio($cdOperador)
    {
        $operador = Operador::findOneByCdoperador($cdOperador);
        
        return $operador->getNrparcnegocio();
    }

    public static function validaInclusaoParticReuniao($nrParc, $nrReuniao) {
        $participante = GpeReuniaoparticip::findOneByNrparcnegocioAndNrreuniaoAndNrorg($nrParc, $nrReuniao, \Geral\Util\Ambiente::getNrorg());

        if (is_object($participante)) {
            return true;
        }

        return false;
    }

    public static function verificaTipoReuniao($nrTipoReuniao, $nrOrg)
    {
        $tipoComReuniao = Gpetipocomitetiporeuniao::findByNrtiporeuniaoAndNrorg($nrTipoReuniao, $nrOrg);
        $tiposComite = $tipoComiteAux = '';
        
        if(empty($tipoComReuniao)) {
            return false;
        }
        
        foreach($tipoComReuniao as $tipo) {
            $nrTipoComite = $tipo->getNrtipocomite();
            $tipoComite   = Gpetipocomite::findOneByNrtipocomiteAndNrorg($nrTipoComite, $nrOrg);
            
            if($tipoComiteAux != $tipoComite->getNmtipocomite()) {
                $tipoComiteAux = $tipoComite->getNmtipocomite();
                $tiposComite .= ' "'.$tipoComite->getNmtipocomite().'"'.',';
            }
        }
        
        return rtrim($tiposComite, ',');
    }
    
    public static function deleteParticipantesReuniao($nrReuniao, $nrOrg)
    {
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        $connection = \Setforms2\Shared\Registry::getEntityManager();        
        $reuniaoParticip = GpeReuniaoparticip::findByNrreuniaoAndNrorg($nrReuniao, $nrOrg);
        
        try {
            foreach ($reuniaoParticip as $participante) {
                $participante->delete();
            }
            
            $connection->flush();          
            $db->getConn()->commit();
        }catch(\Exception $e){
            $db->getConn()->rollback();
            throw $e;
        }        
    }
    
    public static function deleteItensReuniao($nrReuniao, $nrOrg)
    {
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        $connection = \Setforms2\Shared\Registry::getEntityManager();        
        $reuniaoItens = GpeReuniaoitem::findByNrreuniaoAndNrorg($nrReuniao, $nrOrg);
        
        try {
            foreach ($reuniaoItens as $item) {
                $item->delete();
            }
            
            $connection->flush();          
            $db->getConn()->commit();
        }catch(\Exception $e){
            $db->getConn()->rollback();
            throw $e;
        }        
    }
}
