CREATE OR REPLACE PROCEDURE ATUALIZA_ESTOQUE_CONS(
   P_FILIMOVI   IN ITLANCTOEST.CDFILIMOVI%TYPE,
   P_PRODUTO    IN ITLANCTOEST.CDPRODUTO%TYPE,
   P_DTINICIAL  IN ITLANCTOEST.DTLANCMOVI%TYPE,
   P_DTFINAL    IN ITLANCTOEST.DTLANCMOVI%TYPE)
AS

BEGIN

   DECLARE
      V_PDTINICIAL    DATE;
      V_FILIAUX       VARCHAR2(04);
      V_IDESTONEG     VARCHAR2(04);
      V_DTINICIAL     DATE;
      V_DTINICAUX     DATE;
      V_DTINICEST     DATE;
      V_DTINICPOS     DATE;
      V_DTFINAL       DATE;
      V_COUNTPOS      NUMBER;
      V_QTDEESTO      NUMBER;
      V_VALRESTO      NUMBER;
      V_VALRBRUT      NUMBER;
      V_VALRESTOM1    NUMBER;
      V_VALRBRUTM1    NUMBER;
      V_VALRESTOM2    NUMBER;
      V_VALRBRUTM2    NUMBER;
      V_QTDEANTE      NUMBER;
      V_VRESTANT      NUMBER;
      V_VRBRUANT      NUMBER;
      V_VRESTANTM1    NUMBER;
      V_VRBRUANTM1    NUMBER;
      V_VRESTANTM2    NUMBER;
      V_VRBRUANTM2    NUMBER;
      V_QTDEESTOPOS   NUMBER;
      V_VALRESTOPOS   NUMBER;
      V_VALRBRUTPOS   NUMBER;
      V_VALRESTOPOSM1 NUMBER;
      V_VALRBRUTPOSM1 NUMBER;
      V_VALRESTOPOSM2 NUMBER;
      V_VALRBRUTPOSM2 NUMBER;
      V_QTDEANTEPOS   NUMBER;
      V_VRESTANTPOS   NUMBER;
      V_VRBRUANTPOS   NUMBER;
      V_VRESTANTPOSM1 NUMBER;
      V_VRBRUANTPOSM1 NUMBER;
      V_VRESTANTPOSM2 NUMBER;
      V_VRBRUANTPOSM2 NUMBER;
      V_VRINDICE1     NUMBER;
      V_VRINDICE2     NUMBER;

      V_DTSALDO       DATE;
      V_EXISMOV       VARCHAR2(01);
      V_POSIZERO      VARCHAR2(01);
      V_DTPOSESTCON   DATE;
      V_LANCESTQ    VARCHAR2(100);
      V_DTCUSTCALC    DATE;
      V_DTRECALCEST   DATE;
      V_DTAUXILIAR    DATE;
      V_UTILLOTE      VARCHAR2(01);
      V_UTILALMO      VARCHAR2(01);

      V_QTDEAJUSTE    NUMBER;
      V_VLRESTOAJU    NUMBER;
      V_VLRBRUTAJU    NUMBER;
      V_VLRESTOAJUM1  NUMBER;
      V_VLRBRUTAJUM1  NUMBER;
      V_VLRESTOAJUM2  NUMBER;
      V_VLRBRUTAJUM2  NUMBER;
      V_VRQTANT       NUMBER;
      V_VRESTOANT     NUMBER;

      V_CDINDICEMF    VARCHAR2(04);
      V_CDINDICEMF2   VARCHAR2(04);

      V_CDTPINDICE    VARCHAR2(01);
      V_IDPERVALOR    VARCHAR2(01);
      V_CDTPINDICE2   VARCHAR2(01);
      V_IDPERVALOR2   VARCHAR2(01);
      V_VRCLOGCON     NUMBER;
      V_VRCLOGCONANT  NUMBER;   
      V_VRCLOGCONM1   NUMBER;   
      V_VRCLOGCONAM1  NUMBER;   
      V_VRCLOGCONM2   NUMBER;   
      V_VRCLOGCONAM2  NUMBER;   
      V_VRSEGUCON     NUMBER;
      V_VRSEGUCONANT  NUMBER;
      V_VRSEGUCONM1   NUMBER;
      V_VRSEGUCONAM1  NUMBER;
      V_VRSEGUCONM2   NUMBER;
      V_VRSEGUCONAM2  NUMBER;
      V_CUSTPROD      NUMBER;
   BEGIN
      V_PDTINICIAL := TRUNC(P_DTINICIAL);

      SELECT MAX(CDTPINDICE),  MAX(IDPERVALOR),  MAX(CDINDICEMF),
             MAX(CDTPINDICE2), MAX(IDPERVALOR2), MAX(CDINDICEMF2)
      INTO V_CDTPINDICE,  V_IDPERVALOR,  V_CDINDICEMF,
           V_CDTPINDICE2, V_IDPERVALOR2, V_CDINDICEMF2
      FROM PARAMGERAL;

      SELECT MAX(IDUTILLOTE),
             MAX(IDUTILALMOX)
      INTO V_UTILLOTE,
           V_UTILALMO
      FROM PARAMFILIAL
      WHERE CDFILIAL = P_FILIMOVI;

      IF (NVL(V_UTILLOTE, 'N') = 'S') OR (NVL(V_UTILALMO, 'N') = 'S') THEN
         /* LER OS PRODUTOS QUE SERO ATUALIZADOS  */
         SELECT (MAX(DTRECALCEST))
         INTO V_DTRECALCEST
         FROM PRODLCESTOQ
         WHERE (CDFILIAL     = P_FILIMOVI)     AND
               (CDPRODUTO    = P_PRODUTO);

         V_DTRECALCEST := TRUNC(V_DTRECALCEST);

        /* ATUALIZA AS DATAS INICIAL/FINAL PARA ATUALIZAR TODO PERODO */
         SELECT MIN(DTLANCMOVI) INTO V_DTINICEST
         FROM ITLANCTOEST
         WHERE (CDFILIMOVI   = P_FILIMOVI)     AND
               (CDPRODMOVI   = P_PRODUTO);

         SELECT MIN(DTPOSESTCON) INTO V_DTINICPOS
         FROM POSESTCONS
         WHERE (CDFILIAL     = P_FILIMOVI) AND
               (CDPRODUTO    = P_PRODUTO);

         /* DATA INICIAL */

         IF NOT(V_DTRECALCEST IS NULL) AND
            (V_DTRECALCEST < V_PDTINICIAL) THEN
            V_DTINICIAL := V_DTRECALCEST;
         ELSE
            V_DTINICIAL := V_PDTINICIAL;
         END IF;


         IF NOT(V_DTINICEST IS NULL) OR
            NOT(V_DTINICPOS IS NULL) THEN

            IF NOT(V_DTINICEST IS NULL) THEN
               V_DTINICAUX := V_DTINICEST;
            END IF;

            IF NOT(V_DTINICPOS IS NULL) THEN
               IF (V_DTINICPOS < V_DTINICAUX) THEN
                   V_DTINICAUX := V_DTINICPOS;
               END IF;
            END IF;

            IF (V_DTINICIAL < V_DTINICAUX) THEN
                V_DTINICIAL := V_DTINICAUX;
            END IF;

            DELETE POSESTCONS
            WHERE (CDFILIAL     = P_FILIMOVI)     AND
                  (CDPRODUTO    = P_PRODUTO)      AND
                  (DTPOSESTCON <= V_DTINICEST)    AND
                  (VRCUSPRLISTP IS NULL);
         END IF;

         /* DATA FINAL */
         SELECT MAX(DTLANCMOVI) INTO V_DTFINAL
         FROM ITLANCTOEST
         WHERE (CDFILIMOVI   = P_FILIMOVI)     AND
               (CDPRODMOVI   = P_PRODUTO);

         IF V_DTFINAL IS NULL THEN
            V_DTFINAL := P_DTFINAL;
         ELSE
            IF (V_DTFINAL <= P_DTFINAL) THEN
                V_DTFINAL := P_DTFINAL;
            END IF;
         END IF;

         SELECT NVL(MAX(QTESTDIACON),0),
                NVL(MAX(VRESTDIACON),0),
                NVL(MAX(VRESTBRUTCON),0),
                NVL(MAX(VRESTDIACOM1),0) ,
                NVL(MAX(VRESTBRUTCM1),0),
                NVL(MAX(VRESTDIACOM2),0) ,
                NVL(MAX(VRESTBRUTCM2),0),
                NVL(MAX(QTESTANTCON),0),
                NVL(MAX(VRESTANTCON),0),
                NVL(MAX(VRBRUTANTCON),0),
                NVL(MAX(VRESTANTCOM1),0) ,
                NVL(MAX(VRBRUTANTCM1),0),
                NVL(MAX(VRESTANTCOM2),0) ,
                NVL(MAX(VRBRUTANTCM2),0),
                MAX(DTPOSESTCON),
                NVL(MAX(VRCLOGCON),0),
                NVL(MAX(VRCLOGCONANT),0),
                NVL(MAX(VRCLOGCONM1),0),
                NVL(MAX(VRCLOGCONAM1),0),
                NVL(MAX(VRCLOGCONM2),0),
                NVL(MAX(VRCLOGCONAM2),0),
                NVL(MAX(VRSEGUCON),0),
                NVL(MAX(VRSEGUCONANT),0),
                NVL(MAX(VRSEGUCONM1),0),
                NVL(MAX(VRSEGUCONAM1),0),
                NVL(MAX(VRSEGUCONM2),0),
                NVL(MAX(VRSEGUCONAM2),0)
         INTO   V_QTDEESTOPOS,
                V_VALRESTOPOS,
                V_VALRBRUTPOS,
                V_VALRESTOPOSM1,
                V_VALRBRUTPOSM1,
                V_VALRESTOPOSM2,
                V_VALRBRUTPOSM2,
                V_QTDEANTEPOS,
                V_VRESTANTPOS,
                V_VRBRUANTPOS,
                V_VRESTANTPOSM1,
                V_VRBRUANTPOSM1,
                V_VRESTANTPOSM2,
                V_VRBRUANTPOSM2,
                V_DTAUXILIAR,
                V_VRCLOGCON,
                V_VRCLOGCONANT,
                V_VRCLOGCONM1,
                V_VRCLOGCONAM1,
                V_VRCLOGCONM2,
                V_VRCLOGCONAM2,
                V_VRSEGUCON,
                V_VRSEGUCONANT,
                V_VRSEGUCONM1,
                V_VRSEGUCONAM1,
                V_VRSEGUCONM2,
                V_VRSEGUCONAM2
         FROM POSESTCONS
         WHERE (CDFILIAL     = P_FILIMOVI)     AND
               (CDPRODUTO    = P_PRODUTO)      AND
               (DTPOSESTCON  = (SELECT MAX(DTPOSESTCON)
                                FROM POSESTCONS
                                WHERE (CDFILIAL     = P_FILIMOVI)     AND
                                      (CDPRODUTO    = P_PRODUTO)      AND
                                      (DTPOSESTCON  <= V_DTINICIAL)));
         DELETE POSESTCONS
         WHERE (CDFILIAL     = P_FILIMOVI)     AND
               (CDPRODUTO    = P_PRODUTO)      AND
               (DTPOSESTCON  > V_DTINICIAL)    AND
               (VRCUSPRLISTP IS NULL);

         /* ATUALIZA SALDO DE ESTOQUE DESDE A DATA INICIAL */
         /* AT A DATA DE PROCESSAMENTO                    */

         V_EXISMOV := 'N';
         V_DTSALDO := V_DTINICIAL;
         V_LANCESTQ := 'X';

         V_QTDEESTO   := V_QTDEESTOPOS;

         V_VALRESTO   := V_VALRESTOPOS;
         V_VALRBRUT   := V_VALRBRUTPOS;
         V_VALRESTOM1 := V_VALRESTOPOSM1;
         V_VALRBRUTM1 := V_VALRBRUTPOSM1;
         V_VALRESTOM2 := V_VALRESTOPOSM2;
         V_VALRBRUTM2 := V_VALRBRUTPOSM2;
         V_QTDEANTE   := V_QTDEANTEPOS;
         V_VRESTANT   := V_VRESTANTPOS;
         V_VRBRUANT   := V_VRBRUANTPOS;
         V_VRESTANTM1 := V_VRESTANTPOSM1;
         V_VRBRUANTM1 := V_VRBRUANTPOSM1;
         V_VRESTANTM2 := V_VRESTANTPOSM2;
         V_VRBRUANTM2 := V_VRBRUANTPOSM2;

        IF (V_QTDEESTO <> 0) THEN
            V_QTDEANTE   := V_QTDEESTOPOS;
            V_VRESTANT   := V_VRESTANTPOS;
            V_VRBRUANT   := V_VALRBRUTPOS;
            V_VRESTANTM1 := V_VRESTANTPOSM1;
            V_VRBRUANTM1 := V_VALRBRUTPOSM1;
            V_VRESTANTM2 := V_VRESTANTPOSM2;
            V_VRBRUANTM2 := V_VALRBRUTPOSM2;
         END IF;

         FOR C_LANCTOEST IN (SELECT I.IDTIPOMOVI,   I.DTLANCMOVI,  NVL(I.VRLANCTOEST, 0) VRLANCTOEST,
                                    NVL(I.VRLANCTOBRUT,0) VRLANCTOBRUT, I.QTLANCTOEST, I.IDALTCMEDMV, I.CDFILIAL,
                                    I.NRLANCESTQ,  I.CDALMOXARIFE, I.CDLOCALESTOQ, I.NRLOTEESTQ, I.NRSUBLOTE,
                                    I.VRCUSTLOGLAN, I.VRSEGULOGLAN, L.CDTIPOOPER
                             FROM ITLANCTOEST I, LANCTOESTOQ L, PARAMFILIAL P, PRODFILI PF
                             WHERE (I.CDFILIMOVI   = P_FILIMOVI  ) AND
                                   (I.CDPRODMOVI   = P_PRODUTO   ) AND
                                   (I.CDFILIAL = L.CDFILIAL      ) AND
                                   (I.NRLANCESTQ = L.NRLANCESTQ  ) AND
                                   (I.DTLANCMOVI   >= V_DTINICIAL) AND
                                   (I.DTLANCMOVI   <= V_DTFINAL  ) AND
                                   (I.CDFILIMOVI = P.CDFILIAL      ) AND
                                   (I.CDFILIMOVI = PF.CDFILIAL     ) AND
                                   (I.CDPRODMOVI = PF.CDPRODUTO  ) AND
                                   (NVL(I.IDEVOLESTOQ,'S') = 'S' ) AND
                                   (((P.IDUTILALMOX = 'S') AND(I.CDALMOXARIFE <> ' '))OR((P.IDUTILALMOX = 'N' )AND(I.CDALMOXARIFE = ' ')))AND
                                   (((P.IDUTILLCESTQ = 'S')AND(I.CDLOCALESTOQ <> ' '))OR((P.IDUTILLCESTQ = 'N') AND (I.CDLOCALESTOQ = ' '))) AND
                                   ((P.IDUTILLOTE  = 'S') AND(((PF.IDUTCTRLLOTE = 'S') AND(I.NRLOTEESTQ <>' '))OR
                                                              ((PF.IDUTCTRLLOTE = 'N')AND( I.NRLOTEESTQ = ' ')))OR
                                    (P.IDUTILLOTE  = 'N') AND ( I.NRLOTEESTQ = ' '))
                             ORDER BY I.DTLANCMOVI, NVL(I.IDORDEMCLC, I.IDTIPOMOVI), I.NRLANCESTQ, I.NRSEQUITEM) LOOP

            IF (V_CDINDICEMF IS NOT NULL) THEN
               SELECT MAX(VRINDICE)
               INTO V_VRINDICE1
               FROM  INDICE I, MOVINDICE M
               WHERE I.CDTPINDICE = V_CDTPINDICE AND
                     I.IDPERVALOR = V_IDPERVALOR AND
                     I.CDINDICE   = V_CDINDICEMF AND
                     I.CDTPINDICE = M.CDTPINDICE AND
                     I.IDPERVALOR = M.IDPERVALOR AND
                     I.CDINDICE   = M.CDINDICE   AND
                     TO_CHAR(M.DTREFIND,'DD/MM/YYYY')  =  TO_CHAR(C_LANCTOEST.DTLANCMOVI,'DD/MM/YYYY');

                 IF (NVL(V_VRINDICE1,0) = 0) THEN
                    raise_application_error(-20501, 'ndice Financeiro Parametrizado na Personalizao do Sistema no Possui valor Cadastrado para a Data '||TO_CHAR(C_LANCTOEST.DTLANCMOVI,'DD/MM/YYYY')  , True);
                 END IF;
            END IF;

            IF (V_CDINDICEMF2 IS NOT NULL) THEN
               SELECT MAX(VRINDICE)
               INTO V_VRINDICE2
               FROM  INDICE I, MOVINDICE M
               WHERE I.CDTPINDICE = V_CDTPINDICE2 AND
                     I.IDPERVALOR = V_IDPERVALOR2 AND
                     I.CDINDICE   = V_CDINDICEMF2 AND
                     I.CDTPINDICE = M.CDTPINDICE AND
                     I.IDPERVALOR = M.IDPERVALOR AND
                     I.CDINDICE   = M.CDINDICE   AND
                     TO_CHAR(M.DTREFIND,'DD/MM/YYYY')  =  TO_CHAR(C_LANCTOEST.DTLANCMOVI,'DD/MM/YYYY');

              IF (NVL(V_VRINDICE2,0) = 0) THEN
                 raise_application_error(-20501, 'ndice Financeiro Parametrizado na Personalizao do Sistema no Possui valor Cadastrado para a Data '||TO_CHAR(C_LANCTOEST.DTLANCMOVI,'DD/MM/YYYY')  , True);
              END IF;
            END IF;

            IF (V_DTSALDO > C_LANCTOEST.DTLANCMOVI) THEN
               V_DTSALDO := C_LANCTOEST.DTLANCMOVI + 1;
            END IF;

            IF (V_QTDEESTO <> 0) THEN
               V_QTDEANTE    := V_QTDEESTO;
               V_VRESTANT    := V_VALRESTO;
               V_VRBRUANT    := V_VALRBRUT;
               V_VRESTANTM1  := V_VALRESTOM1;
               V_VRBRUANTM1  := V_VALRBRUTM1;
               V_VRESTANTM2  := V_VALRESTOM2;
               V_VRBRUANTM2  := V_VALRBRUTM2;

               V_VRCLOGCONANT  := V_VRCLOGCON;
               V_VRCLOGCONAM1  := V_VRCLOGCONM1;
               V_VRCLOGCONAM2  := V_VRCLOGCONM2;
               V_VRSEGUCONANT  := V_VRSEGUCON;
               V_VRSEGUCONAM1  := V_VRSEGUCONM1;
               V_VRSEGUCONAM2  := V_VRSEGUCONM2;


            END IF;

            IF (C_LANCTOEST.DTLANCMOVI + 1) = V_DTAUXILIAR THEN
               V_QTDEESTO   := 0;
               V_VALRESTO   := 0;
               V_VALRBRUT   := 0;
               V_QTDEANTE   := 0;
               V_VRESTANT   := 0;
               V_VRBRUANT   := 0;
               V_VRESTANTM1 := 0;
               V_VRBRUANTM1 := 0;
               V_VRESTANTM2 := 0;
               V_VRBRUANTM2 := 0;

               V_VRCLOGCONANT  := 0;
               V_VRCLOGCONAM1  := 0;
               V_VRCLOGCONAM2  := 0;
               V_VRSEGUCONANT  := 0;
               V_VRSEGUCONAM1  := 0;
               V_VRSEGUCONAM2  := 0;

            END IF;

            V_EXISMOV := 'S';

            /* GRAVAO DOS SALDOS DIRIOS PARA O PRODUTO */
            /* TRATAMENTO PARA CADA REGISTRO DE LANAMENTO DE ESTOQUE */
            /* ATUALIZAO REALIZADA NA DATA 22/06/2009 SOLICITAO 78472 */

            IF (C_LANCTOEST.IDTIPOMOVI = '0') THEN    /* IMPLANTAO */
               IF V_LANCESTQ <> C_LANCTOEST.CDFILIAL||C_LANCTOEST.NRLANCESTQ||C_LANCTOEST.CDALMOXARIFE||
                     C_LANCTOEST.CDLOCALESTOQ||C_LANCTOEST.NRLOTEESTQ||C_LANCTOEST.NRSUBLOTE THEN
                  CALCULA_SALDO_ANTERIOR(C_LANCTOEST.CDFILIAL, C_LANCTOEST.NRLANCESTQ,
                                         P_FILIMOVI, P_PRODUTO, C_LANCTOEST.CDALMOXARIFE,
                                         C_LANCTOEST.CDLOCALESTOQ, C_LANCTOEST.NRLOTEESTQ,
                                         C_LANCTOEST.NRSUBLOTE, C_LANCTOEST.DTLANCMOVI,
                                         V_QTDEAJUSTE, V_VLRESTOAJU, V_VLRBRUTAJU, V_VRQTANT, V_VRESTOANT, 'N');

                  V_QTDEESTO := V_QTDEESTO + (C_LANCTOEST.QTLANCTOEST - V_QTDEAJUSTE);
                  IF V_QTDEAJUSTE <> 0 THEN
                     V_VALRESTO := V_VALRESTO + (C_LANCTOEST.VRLANCTOEST - V_VLRESTOAJU);
                     V_VALRBRUT := V_VALRBRUT + (C_LANCTOEST.VRLANCTOBRUT - V_VLRBRUTAJU);
                  ELSE
                     V_VALRESTO := V_VALRESTO + C_LANCTOEST.VRLANCTOEST;
                     V_VALRBRUT := V_VALRBRUT + C_LANCTOEST.VRLANCTOBRUT;
                  END IF;
               ELSE
                  V_QTDEESTO := V_QTDEESTO + C_LANCTOEST.QTLANCTOEST;
                  V_VALRESTO := V_VALRESTO + C_LANCTOEST.VRLANCTOEST;
                  V_VALRBRUT := V_VALRBRUT + C_LANCTOEST.VRLANCTOBRUT;
               END IF;

            ELSIF (C_LANCTOEST.IDTIPOMOVI = '1') THEN    /* AJUSTES     */

               CALCULA_SALDO_ANTERIOR(C_LANCTOEST.CDFILIAL, C_LANCTOEST.NRLANCESTQ,
                                      P_FILIMOVI, P_PRODUTO, C_LANCTOEST.CDALMOXARIFE,
                                      C_LANCTOEST.CDLOCALESTOQ, C_LANCTOEST.NRLOTEESTQ,
                                      C_LANCTOEST.NRSUBLOTE, C_LANCTOEST.DTLANCMOVI,
                                      V_QTDEAJUSTE, V_VLRESTOAJU, V_VLRBRUTAJU, V_VRQTANT, V_VRESTOANT,'N');

               IF NVL(C_LANCTOEST.IDALTCMEDMV,'N') <> 'S' THEN


                   IF V_QTDEAJUSTE <> 0 THEN
                     V_VRBRUANT := V_VALRBRUT;
                     V_VRESTANT := V_VALRESTO;
                     V_QTDEANTE := V_QTDEESTO;

                     V_VRESTANTM1 := V_VALRESTOM1;
                     V_VRBRUANTM1 := V_VALRBRUTM1;
                     V_VRESTANTM2 := V_VALRESTOM2;
                     V_VRBRUANTM2 := V_VALRBRUTM2;

                     V_VRCLOGCONANT  := V_VRCLOGCON;
                     V_VRCLOGCONAM1  := V_VRCLOGCONM1;
                     V_VRCLOGCONAM2  := V_VRCLOGCONM2;
                     V_VRSEGUCONANT  := V_VRSEGUCON;
                     V_VRSEGUCONAM1  := V_VRSEGUCONM1;
                     V_VRSEGUCONAM2  := V_VRSEGUCONM2;


                     V_VALRBRUT := V_VALRBRUT + ((V_VLRBRUTAJU/V_QTDEAJUSTE)*(C_LANCTOEST.QTLANCTOEST - V_QTDEAJUSTE));
                     V_VALRESTO := V_VALRESTO + ((V_VLRESTOAJU/V_QTDEAJUSTE)*(C_LANCTOEST.QTLANCTOEST - V_QTDEAJUSTE));
                  ELSE

                     IF V_VLRESTOAJU = 0 THEN


                        IF ABS(V_VRQTANT) > 0 AND ABS(C_LANCTOEST.QTLANCTOEST) > 0 THEN
                           V_VALRBRUT := V_VALRBRUT + (V_VRESTOANT/V_VRQTANT)*C_LANCTOEST.QTLANCTOEST;
                           V_VALRESTO := V_VALRESTO + (V_VRESTOANT/V_VRQTANT)*C_LANCTOEST.QTLANCTOEST;
                        END IF;
                     ELSE

                        IF ABS(V_VRQTANT) > 0 THEN
                           V_VALRBRUT := V_VALRBRUT + ((V_VLRBRUTAJU/V_VRQTANT)* C_LANCTOEST.QTLANCTOEST);
                           V_VALRESTO := V_VALRESTO + ((V_VLRESTOAJU/V_VRQTANT) * C_LANCTOEST.QTLANCTOEST);
                        END IF;
                     END IF;
                  END IF;
               END IF;
               V_QTDEESTO := V_QTDEESTO + (C_LANCTOEST.QTLANCTOEST - V_QTDEAJUSTE);

            ELSIF (C_LANCTOEST.IDTIPOMOVI = '2') THEN    /* ENTRADA     */

               IF (C_LANCTOEST.QTLANCTOEST <> 0 OR C_LANCTOEST.CDTIPOOPER = '03') THEN
                  V_QTDEESTO := V_QTDEESTO + C_LANCTOEST.QTLANCTOEST;

                  V_VRCLOGCON   := V_VRCLOGCON + C_LANCTOEST.VRCUSTLOGLAN;
                  V_VRSEGUCON   := V_VRSEGUCON + C_LANCTOEST.VRSEGULOGLAN;

                  IF C_LANCTOEST.QTLANCTOEST = 0 THEN
                     V_VALRBRUT := V_VALRBRUT + C_LANCTOEST.VRLANCTOBRUT;
                     V_VALRESTO := V_VALRESTO + C_LANCTOEST.VRLANCTOEST;
                  ELSE
                     V_VALRBRUT := V_VALRBRUT + (C_LANCTOEST.QTLANCTOEST*C_LANCTOEST.VRLANCTOBRUT);
                     V_VALRESTO := V_VALRESTO + (C_LANCTOEST.QTLANCTOEST*C_LANCTOEST.VRLANCTOEST);
                  END IF;

                  IF V_QTDEESTO  = 0 THEN
                     V_VALRBRUT   := 0;
                     V_VALRESTO   := 0;
                  END IF;
               END IF;
            ELSIF (C_LANCTOEST.IDTIPOMOVI = '3') THEN    /* RETIRADA    */
               CALCULA_SALDO_ANTERIOR(C_LANCTOEST.CDFILIAL, C_LANCTOEST.NRLANCESTQ,
                                      P_FILIMOVI, P_PRODUTO, C_LANCTOEST.CDALMOXARIFE,
                                      C_LANCTOEST.CDLOCALESTOQ, C_LANCTOEST.NRLOTEESTQ,
                                      C_LANCTOEST.NRSUBLOTE, C_LANCTOEST.DTLANCMOVI,
                                      V_QTDEAJUSTE, V_VLRESTOAJU, V_VLRBRUTAJU, V_VRQTANT, V_VRESTOANT, 'N');
               IF V_QTDEAJUSTE <> 0 THEN
                  V_VALRBRUT := V_VALRBRUT - ((V_VLRBRUTAJU/V_QTDEAJUSTE)*C_LANCTOEST.QTLANCTOEST);
                  V_VALRESTO := V_VALRESTO - ((V_VLRESTOAJU/V_QTDEAJUSTE)*C_LANCTOEST.QTLANCTOEST);
               ELSE
                  IF V_VRQTANT > 0 THEN
                     V_VALRBRUT := V_VALRBRUT - ((V_VLRBRUTAJU/V_VRQTANT)*C_LANCTOEST.QTLANCTOEST);
                     V_VALRESTO := V_VALRESTO - ((V_VLRESTOAJU/V_VRQTANT)*C_LANCTOEST.QTLANCTOEST);
                  ELSE
                     V_VALRBRUT := V_VALRBRUT - (V_VLRBRUTAJU*C_LANCTOEST.QTLANCTOEST);
                     V_VALRESTO := V_VALRESTO - (V_VLRESTOAJU*C_LANCTOEST.QTLANCTOEST);
                  END IF;
               END IF;
               V_QTDEESTO := V_QTDEESTO - C_LANCTOEST.QTLANCTOEST;

               IF ROUND(V_QTDEESTO,8) = 0 THEN
                  V_QTDEESTO := 0;
               END IF;

               IF V_QTDEESTO  = 0 THEN
                  V_VALRBRUT   := 0;
                  V_VALRESTO   := 0;
               END IF;

            ELSIF (C_LANCTOEST.IDTIPOMOVI = '4') THEN    /* SADA       */
               IF (C_LANCTOEST.QTLANCTOEST <> 0  OR C_LANCTOEST.CDTIPOOPER = '03') THEN
                  CALCULA_SALDO_ANTERIOR(C_LANCTOEST.CDFILIAL, C_LANCTOEST.NRLANCESTQ,
                                         P_FILIMOVI, P_PRODUTO, C_LANCTOEST.CDALMOXARIFE,
                                         C_LANCTOEST.CDLOCALESTOQ, C_LANCTOEST.NRLOTEESTQ,
                                         C_LANCTOEST.NRSUBLOTE, C_LANCTOEST.DTLANCMOVI,
                                         V_QTDEAJUSTE, V_VLRESTOAJU, V_VLRBRUTAJU, V_VRQTANT, V_VRESTOANT, 'N');

                  IF V_QTDEAJUSTE <> 0 THEN
                     V_VALRBRUT := V_VALRBRUT - ((V_VLRBRUTAJU/V_QTDEAJUSTE)*C_LANCTOEST.QTLANCTOEST);
                     V_VALRESTO := V_VALRESTO - ((V_VLRESTOAJU/V_QTDEAJUSTE)*C_LANCTOEST.QTLANCTOEST);
                  ELSE
                     IF V_VRQTANT > 0 THEN
                        V_VALRBRUT := V_VALRBRUT - ((V_VLRBRUTAJU/V_VRQTANT)*C_LANCTOEST.QTLANCTOEST);
                        V_VALRESTO := V_VALRESTO - ((V_VLRESTOAJU/V_VRQTANT)*C_LANCTOEST.QTLANCTOEST);
                     ELSE
                        V_VALRBRUT := V_VALRBRUT - (V_VLRBRUTAJU*C_LANCTOEST.QTLANCTOEST);
                        V_VALRESTO := V_VALRESTO - (V_VLRESTOAJU*C_LANCTOEST.QTLANCTOEST);
                     END IF;
                  END IF;

                  V_QTDEESTO := V_QTDEESTO - C_LANCTOEST.QTLANCTOEST;

                  IF ROUND(V_QTDEESTO,8) = 0 THEN
                     V_QTDEESTO := 0;
                  END IF;

                  IF V_QTDEESTO  = 0 THEN
                     V_VALRBRUT   := 0;
                     V_VALRESTO   := 0;
                  END IF;
               END IF;
            ELSIF (C_LANCTOEST.IDTIPOMOVI = '5') THEN    /* DEV. FORN.  */
               CALCULA_SALDO_ANTERIOR(C_LANCTOEST.CDFILIAL, C_LANCTOEST.NRLANCESTQ,
                                      P_FILIMOVI, P_PRODUTO, C_LANCTOEST.CDALMOXARIFE,
                                      C_LANCTOEST.CDLOCALESTOQ, C_LANCTOEST.NRLOTEESTQ,
                                      C_LANCTOEST.NRSUBLOTE, C_LANCTOEST.DTLANCMOVI,
                                      V_QTDEAJUSTE, V_VLRESTOAJU, V_VLRBRUTAJU, V_VRQTANT, V_VRESTOANT, 'N');

               IF V_QTDEAJUSTE <> 0 THEN
                  V_CUSTPROD :=  V_VLRESTOAJU/V_QTDEAJUSTE;
               ELSE
                  V_CUSTPROD :=  V_VLRESTOAJU;
               END IF;

               IF (V_VALRESTO - (C_LANCTOEST.QTLANCTOEST * C_LANCTOEST.VRLANCTOEST)) < 0 THEN
                    V_VALRESTO := V_VALRESTO - (C_LANCTOEST.QTLANCTOEST * V_CUSTPROD);
               ELSE
                    V_VALRESTO := (V_VALRESTO - (C_LANCTOEST.QTLANCTOEST * C_LANCTOEST.VRLANCTOEST));
               END IF;

               IF V_QTDEAJUSTE <> 0 THEN
                  V_CUSTPROD :=  V_VLRBRUTAJU/V_QTDEAJUSTE;
               ELSE
                  V_CUSTPROD :=  V_VLRBRUTAJU;
               END IF;

               IF (V_VALRBRUT - (C_LANCTOEST.QTLANCTOEST * C_LANCTOEST.VRLANCTOBRUT)) < 0 THEN
                    V_VALRBRUT := V_VALRBRUT - (C_LANCTOEST.QTLANCTOEST * V_CUSTPROD);
               ELSE
                    V_VALRBRUT := (V_VALRBRUT - (C_LANCTOEST.QTLANCTOEST * C_LANCTOEST.VRLANCTOBRUT));
               END IF;

               V_QTDEESTO := V_QTDEESTO - C_LANCTOEST.QTLANCTOEST;

               IF V_QTDEESTO  = 0 THEN
                  V_VALRBRUT   := 0;
                  V_VALRESTO   := 0;
               END IF;
            END IF;

            WHILE (V_DTSALDO <= (C_LANCTOEST.DTLANCMOVI + 1)) LOOP

               IF (V_CDINDICEMF IS NOT NULL) AND (V_VRINDICE1 <> 0) THEN
                  V_VALRBRUTM1   := V_VALRBRUT / V_VRINDICE1;
                  V_VALRESTOM1   := V_VALRESTO / V_VRINDICE1;
                  V_VRCLOGCONAM1 := V_VRCLOGCON / V_VRINDICE1;
                  V_VRSEGUCONM1  := V_VRSEGUCON / V_VRINDICE1;

               END IF;

               IF (V_CDINDICEMF2 IS NOT NULL) AND (V_VRINDICE2 <> 0) THEN
                  V_VALRBRUTM2   := V_VALRBRUT / V_VRINDICE2;
                  V_VALRESTOM2   := V_VALRESTO / V_VRINDICE2;
                  V_VRCLOGCONAM2 := V_VRCLOGCON / V_VRINDICE2;
                  V_VRSEGUCONM2  := V_VRSEGUCON / V_VRINDICE2;
               END IF;

               SELECT COUNT(*)
               INTO V_COUNTPOS
               FROM POSESTCONS
               WHERE (CDFILIAL    = P_FILIMOVI)     AND
                     (CDPRODUTO   = P_PRODUTO)      AND
                     (DTPOSESTCON = V_DTSALDO);

               IF (V_COUNTPOS = 0) THEN
                  IF V_QTDEESTO = 0 THEN
                     V_POSIZERO := 'S';
                  ELSE
                     V_POSIZERO := 'N';
                  END IF;
                  IF (V_DTSALDO > C_LANCTOEST.DTLANCMOVI) THEN
                     INSERT INTO POSESTCONS
                        (CDFILIAL,     CDPRODUTO,    DTPOSESTCON,  QTESTDIACON,  VRESTDIACON,  VRESTBRUTCON,
                         IDPOSZEROCON, QTESTANTCON,  VRESTANTCON,  VRBRUTANTCON, VRESTDIACOM1, VRESTBRUTCM1,
                         VRESTANTCOM1, VRBRUTANTCM1, VRESTDIACOM2, VRESTBRUTCM2, VRESTANTCOM2, VRBRUTANTCM2,
                         VRCLOGCON,    VRCLOGCONANT, VRCLOGCONM1,  VRCLOGCONAM1, VRCLOGCONM2,  VRCLOGCONAM2,
                         VRSEGUCON,    VRSEGUCONANT, VRSEGUCONM1,  VRSEGUCONAM1, VRSEGUCONM2,  VRSEGUCONAM2)
                     VALUES (P_FILIMOVI,   P_PRODUTO,      V_DTSALDO,     V_QTDEESTO,     V_VALRESTO,    V_VALRBRUT ,
                             V_POSIZERO,   V_QTDEANTE,     V_VRESTANT,    V_VRBRUANT,     V_VALRESTOM1,  V_VALRBRUTM1,
                             V_VRESTANTM1, V_VRBRUANTM1,   V_VALRESTOM2,  V_VALRBRUTM2,   V_VRESTANTM2,  V_VRBRUANTM2,
                             V_VRCLOGCON,  V_VRCLOGCONANT, V_VRCLOGCONM1, V_VRCLOGCONAM1, V_VRCLOGCONM2, V_VRCLOGCONAM2,
                             V_VRSEGUCON,  V_VRSEGUCONANT, V_VRSEGUCONM1, V_VRSEGUCONAM1, V_VRSEGUCONM2, V_VRSEGUCONAM2);
                  END IF;
               ELSE

                  IF (V_DTSALDO < (C_LANCTOEST.DTLANCMOVI + 1)) THEN
                     IF V_QTDEESTOPOS = 0 THEN
                        V_POSIZERO := 'S';
                     ELSE
                        V_POSIZERO := 'N';
                     END IF;
                     UPDATE POSESTCONS
                     SET QTESTDIACON   = V_QTDEESTOPOS,
                         VRESTDIACON   = V_VALRESTOPOS,
                         VRESTBRUTCON  = V_VALRBRUTPOS,
                         VRESTDIACOM1  = V_VALRESTOPOSM1,
                         VRESTBRUTCM1  = V_VALRBRUTPOSM1,
                         VRESTDIACOM2  = V_VALRESTOPOSM2,
                         VRESTBRUTCM2  = V_VALRBRUTPOSM2,
                         IDPOSZEROCON  = V_POSIZERO,
                         QTESTANTCON   = V_QTDEANTEPOS,
                         VRESTANTCON   = V_VRESTANTPOS,
                         VRBRUTANTCON  = V_VRBRUANTPOS,
                         VRESTANTCOM1  = V_VRESTANTPOSM1,
                         VRBRUTANTCM1  = V_VRBRUANTPOSM1,
                         VRESTANTCOM2  = V_VRESTANTPOSM2,
                         VRBRUTANTCM2  = V_VRBRUANTPOSM2,
                         VRCLOGCON     = V_VRCLOGCON,
                         VRCLOGCONANT  = V_VRCLOGCONANT,
                         VRCLOGCONM1   = V_VRCLOGCONM1,
                         VRCLOGCONAM1  = V_VRCLOGCONAM1,
                         VRCLOGCONM2   = V_VRCLOGCONM2,
                         VRCLOGCONAM2  = V_VRCLOGCONAM2,
                         VRSEGUCON     = V_VRSEGUCON,
                         VRSEGUCONANT  = V_VRSEGUCONANT,
                         VRSEGUCONM1   = V_VRSEGUCONM1,
                         VRSEGUCONAM1  = V_VRSEGUCONAM1,
                         VRSEGUCONM2   = V_VRSEGUCONM2,
                         VRSEGUCONAM2  = V_VRSEGUCONAM2
                     WHERE (CDFILIAL     = P_FILIMOVI)     AND
                           (CDPRODUTO    = P_PRODUTO)      AND
                           (DTPOSESTCON  = V_DTSALDO);
                  ELSE
                     IF V_QTDEESTO = 0 THEN
                        V_POSIZERO := 'S';
                     ELSE
                        V_POSIZERO := 'N';
                     END IF;

                     UPDATE POSESTCONS
                     SET QTESTDIACON  = V_QTDEESTO,
                         VRESTDIACON  = V_VALRESTO,
                         VRESTBRUTCON = V_VALRBRUT,
                         VRESTDIACOM1 = V_VALRESTOM1,
                         VRESTBRUTCM1 = V_VALRBRUTM1,
                         VRESTDIACOM2 = V_VALRESTOM2,
                         VRESTBRUTCM2 = V_VALRBRUTM2,
                         IDPOSZEROCON = V_POSIZERO,
                         QTESTANTCON  = V_QTDEANTE,
                         VRESTANTCON  = V_VRESTANT,
                         VRBRUTANTCON = V_VRBRUANT,
                         VRESTANTCOM1 = V_VRESTANTM1,
                         VRBRUTANTCM1 = V_VRBRUANTM1,
                         VRESTANTCOM2 = V_VRESTANTM2,
                         VRBRUTANTCM2 = V_VRBRUANTM2,
                         VRCLOGCON     = V_VRCLOGCON,
                         VRCLOGCONANT  = V_VRCLOGCONANT,
                         VRCLOGCONM1   = V_VRCLOGCONM1,
                         VRCLOGCONAM1  = V_VRCLOGCONAM1,
                         VRCLOGCONM2   = V_VRCLOGCONM2,
                         VRCLOGCONAM2  = V_VRCLOGCONAM2,
                         VRSEGUCON     = V_VRSEGUCON,
                         VRSEGUCONANT  = V_VRSEGUCONANT,
                         VRSEGUCONM1   = V_VRSEGUCONM1,
                         VRSEGUCONAM1  = V_VRSEGUCONAM1,
                         VRSEGUCONM2   = V_VRSEGUCONM2,
                         VRSEGUCONAM2  = V_VRSEGUCONAM2
                       WHERE (CDFILIAL     = P_FILIMOVI)  AND
                             (CDPRODUTO    = P_PRODUTO)   AND
                             (DTPOSESTCON  = V_DTSALDO);
                  END IF;
               END IF;

               V_DTSALDO  := V_DTSALDO + 1;
            END LOOP;


            /* GUARDA OS VALORES DE ESTOQUE ANTERIORES  PRXIMA MOVIMENTAO */
            V_QTDEESTOPOS   := V_QTDEESTO;
            V_VALRESTOPOS   := V_VALRESTO;
            V_VALRBRUTPOS   := V_VALRBRUT;
            V_VALRESTOPOSM1 := V_VALRESTOM1;
            V_VALRBRUTPOSM1 := V_VALRBRUTM1;
            V_VALRESTOPOSM2 := V_VALRESTOM2;
            V_VALRBRUTPOSM2 := V_VALRBRUTM2;
            V_QTDEANTEPOS   := V_QTDEANTE;
            V_VRESTANTPOS   := V_VRESTANT;
            V_VRBRUANTPOS   := V_VRBRUANT;
            V_VRESTANTPOSM1 := V_VRESTANTM1;
            V_VRBRUANTPOSM1 := V_VRBRUANTM1;
            V_VRESTANTPOSM2 := V_VRESTANTM2;
            V_VRBRUANTPOSM2 := V_VRBRUANTM2;
            V_VRCLOGCONANT  := V_VRCLOGCON;
            V_VRCLOGCONAM1  := V_VRCLOGCONM1;
            V_VRCLOGCONAM2  := V_VRCLOGCONM2;
            V_VRSEGUCONANT  := V_VRSEGUCON;
            V_VRSEGUCONAM1  := V_VRSEGUCONM1;
            V_VRSEGUCONAM2  := V_VRSEGUCONM2;



            V_LANCESTQ := C_LANCTOEST.CDFILIAL||C_LANCTOEST.NRLANCESTQ||C_LANCTOEST.CDALMOXARIFE||
                     C_LANCTOEST.CDLOCALESTOQ||C_LANCTOEST.NRLOTEESTQ||C_LANCTOEST.NRSUBLOTE;
         END LOOP;

         UPDATE POSESTCONS
         SET VRESTDIACON  = 0,
             VRESTBRUTCON = 0,
             VRESTDIACOM1 = 0,
             VRESTBRUTCM1 = 0,
             VRESTDIACOM2 = 0,
             VRESTBRUTCM2 = 0,
             VRCLOGCON     = 0,
             VRCLOGCONM1   = 0,
             VRCLOGCONM2   = 0,
             VRSEGUCON     = 0,
             VRSEGUCONM1   = 0,
             VRSEGUCONM2   = 0
         WHERE (CDFILIAL     = P_FILIMOVI)   AND
               (CDPRODUTO    = P_PRODUTO)    AND
               (DTPOSESTCON >= V_PDTINICIAL) AND
               (QTESTDIACON  = 0);

         UPDATE POSESTCONS
         SET VRESTANTCON  = 0,
             VRBRUTANTCON = 0,
             VRESTANTCOM1 = 0,
             VRBRUTANTCM1 = 0,
             VRESTANTCOM2 = 0,
             VRBRUTANTCM2 = 0,
             VRCLOGCONANT  = 0,
             VRCLOGCONAM1  = 0,
             VRCLOGCONAM2  = 0,
             VRSEGUCONANT  = 0,
             VRSEGUCONAM1  = 0,
             VRSEGUCONAM2  = 0
         WHERE (CDFILIAL     = P_FILIMOVI)   AND
               (CDPRODUTO    = P_PRODUTO)    AND
               (DTPOSESTCON >= V_PDTINICIAL) AND
               (QTESTANTCON  = 0);
      END IF;
   END;
END;
/