CREATE OR REPLACE PROCEDURE ATUALIZA_SALDO_GERAL(
  P_CDEMPRESA IN EMPRESA.CDEMPRESA%TYPE,
  P_CDCONTINI IN CONTCTBL.CDCONTCTBL%TYPE,
  P_CDCONTFIN IN CONTCTBL.CDCONTCTBL%TYPE,
  P_DATAINIC  IN CONTOPECTBL.DTFINALANC%TYPE,
  P_DATAFIM IN CONTOPECTBL.DTFINALANC%TYPE,
  P_CALCSOC IN VARCHAR2)
IS

  V_CDCONTINI   CONTCTBL.CDCONTCTBL%TYPE;
  V_CDCONTFIM   CONTCTBL.CDCONTCTBL%TYPE;
  V_DTFINACONT  DATE;
  DATA_SALDO    DATE;
  V_CONTSALDO   CHAR;
  V_IDSALDEMPR  CHAR;
  V_VERSAO      VARCHAR2(1);
  V_VRSALDO     NUMBER;
  V_VRSALDEMPR  NUMBER;
  V_CONTA       CONTCTBL.CDCONTCTBL%TYPE;
  V_TESTELOOP   CHAR;
  MENOR_DATA    DATE;
  V_COUNT       NUMBER;
  V_DARCOMMIT   NUMBER;
  V_CONTCOMMIT NUMBER;
  V_UTSALDOSOC VARCHAR2(01);
  
BEGIN
    V_DARCOMMIT := 50;
    V_CONTCOMMIT := 1;
    SELECT MAX(SUBSTR(BANNER,7,1))
      INTO V_VERSAO
      FROM V$VERSION
     WHERE BANNER LIKE 'Orac%';

    IF V_VERSAO <> '9' THEN
       COMMIT;
       SET TRANSACTION USE ROLLBACK SEGMENT RBS_TECNISA;
    END IF;

    SELECT MAX(DTFINACONT), MAX(IDSALDEMPR) INTO V_DTFINACONT, V_IDSALDEMPR
      FROM CONTOPECTBL
     WHERE CDEMPRESA = P_CDEMPRESA;

    V_COUNT := 0;
    BEGIN
       SELECT COUNT(*)
         INTO V_COUNT
         FROM CONTCTBL
        WHERE CDCONTCTBL = P_CDCONTFIN
          AND IDTIPOCONT = 'A';
    EXCEPTION
       WHEN NO_DATA_FOUND THEN
          V_COUNT := 0;
    END;

    IF V_COUNT <> 0 THEN
       SELECT MAX(CDCONTCTBL)
         INTO V_CDCONTFIM
         FROM CONTCTBL
        WHERE CDCONTCTBL BETWEEN SUBSTR(P_CDCONTFIN, 1, 1) AND P_CDCONTFIN
          AND (IDCONTCCUS <> 'R');
    ELSE
       SELECT MAX(CDCONTCTBL)
         INTO V_CDCONTFIM
         FROM CONTCTBL
        WHERE CDCONTCTBL BETWEEN SUBSTR(P_CDCONTFIN, 1, 1) AND (P_CDCONTFIN || 'zzzzzzzzzzzzzzzzzzz')
          AND (IDCONTCCUS <> 'R');
    END IF;

    SELECT MIN(CDCONTCTBL)
      INTO V_CDCONTINI
      FROM CONTCTBL
     WHERE (INSTR(P_CDCONTINI,RTRIM(CONTCTBL.CDCONTCTBL)) = 1)
       AND (IDCONTCCUS <> 'R');

    DELETE FROM SALDEMPR
     WHERE (SALDEMPR.CDEMPRESA  = P_CDEMPRESA)
       AND (SALDEMPR.DTSALDEMPR >= P_DATAINIC)
       AND (SALDEMPR.CDCONTCTBL IN (SELECT CDCONTCTBL
                                      FROM CONTCTBL
                                     WHERE (CDCONTCTBL BETWEEN V_CDCONTINI AND V_CDCONTFIM)));

    V_CONTCOMMIT := V_CONTCOMMIT +1;
    DELETE FROM SALDOTRANSF
     WHERE (SALDOTRANSF.CDEMPRESA     = P_CDEMPRESA)
       AND (SALDOTRANSF.DTSALDOTRANSF >= P_DATAINIC)
       AND (SALDOTRANSF.CDCONTCTBL IN (SELECT CDCONTCTBL
                                         FROM CONTCTBL
                                        WHERE (CDCONTCTBL BETWEEN V_CDCONTINI AND V_CDCONTFIM)));
    V_CONTCOMMIT := V_CONTCOMMIT +1 ;

    IF P_DATAFIM IS NOT NULL THEN
       V_DTFINACONT := LAST_DAY(P_DATAFIM);
    ELSE
       V_DTFINACONT := LAST_DAY(V_DTFINACONT);
    END IF;

    FOR MES IN
       (SELECT DISTINCT DTMES PRIMDIA, LAST_DAY(DTDATA) ULTIMODIA
          FROM DATA
         WHERE DTDATA BETWEEN P_DATAINIC AND V_DTFINACONT
         ORDER BY 1) LOOP
         
       /*ATUALIZA SALDO ANTERIOR */
       FOR SALDANT IN
           (SELECT SALDEMPR.CDCONTCTBL, SALDEMPR.DTSALDEMPR, SALDEMPR.VRSALDEMPR
              FROM SALDEMPR, CONTCTBL
             WHERE (SALDEMPR.CDEMPRESA  = P_CDEMPRESA)
               AND (SALDEMPR.CDCONTCTBL BETWEEN V_CDCONTINI AND V_CDCONTFIM)
               AND (SALDEMPR.CDCONTCTBL = CONTCTBL.CDCONTCTBL)
               AND (CONTCTBL.IDCONTCCUS <> 'R')
               AND (SALDEMPR.DTSALDEMPR = (SELECT MAX(S.DTSALDEMPR)
                                             FROM SALDEMPR S
                                            WHERE S.CDCONTCTBL = SALDEMPR.CDCONTCTBL
                                              AND S.CDEMPRESA  = P_CDEMPRESA
                                              AND S.DTSALDEMPR < MES.PRIMDIA))) LOOP

           DATA_SALDO := SALDANT.DTSALDEMPR;
           DATA_SALDO := LAST_DAY(DATA_SALDO);
           
           WHILE (DATA_SALDO <= MES.ULTIMODIA) LOOP
              INSERT INTO SALDEMPR
                 (CDEMPRESA, CDCONTCTBL, DTSALDEMPR, VRSALDEMPR)
                 (SELECT P_CDEMPRESA, CDCONTCTBL, DATA_SALDO, 0
                    FROM CONTCTBL C
                   WHERE NOT EXISTS (SELECT 1
                                       FROM SALDEMPR S
                                      WHERE C.CDCONTCTBL = S.CDCONTCTBL
                                        AND CDEMPRESA = P_CDEMPRESA
                                        AND DTSALDEMPR = DATA_SALDO)
                     AND (INSTR(SALDANT.CDCONTCTBL,RTRIM(C.CDCONTCTBL)) = 1));
                 V_CONTCOMMIT := V_CONTCOMMIT +1 ;
                 IF V_CONTCOMMIT = V_DARCOMMIT THEN
                    V_CONTCOMMIT := 1;
                    COMMIT;
                 END IF;
                 DATA_SALDO := ADD_MONTHS(DATA_SALDO,1);
            END LOOP;


           UPDATE SALDEMPR
              SET VRSALDEMPR = SALDANT.VRSALDEMPR
            WHERE (SALDEMPR.CDEMPRESA  = P_CDEMPRESA)
              AND (SALDEMPR.DTSALDEMPR >= MES.PRIMDIA)
              AND (SALDEMPR.CDCONTCTBL  = SALDANT.CDCONTCTBL);
           V_CONTCOMMIT := V_CONTCOMMIT +1 ;
           IF V_CONTCOMMIT = V_DARCOMMIT THEN
              V_CONTCOMMIT := 1;
              COMMIT;
           END IF;
       END LOOP;

       /* ATUALIZA O SALDO MENSAL DE ACORDO COM OS LANCAMENTOS CONTABEIS OU IMPLANACOES DE SALDO */
       FOR ATUALIZA IN
          (SELECT CDCONTCTBL, MENOR_DATA, DTIMPSALDO, VRIMPSALDO
             FROM (SELECT C.CDCONTCTBL, I.DTIMPSALDO, ROUND(I.VRIMPSALDO, 2) VRIMPSALDO,
                          TRUNC(MIN(DTLANCCONT)) AS MENOR_DATA
                     FROM CONTCTBL C LEFT JOIN LANCCONT L
                                            ON L.CDEMPRESA   = P_CDEMPRESA
                                           AND L.DTLANCCONT BETWEEN MES.PRIMDIA AND MES.ULTIMODIA
                                           AND L.CDCONTCTBL = C.CDCONTCTBL
                                     LEFT JOIN IMPLANTSALDO I
                                            ON I.CDEMPRESA   = P_CDEMPRESA
                                           AND I.DTIMPSALDO BETWEEN MES.PRIMDIA AND MES.ULTIMODIA
                                            AND I.CDCONTCTBL = C.CDCONTCTBL
                    WHERE C.CDCONTCTBL BETWEEN V_CDCONTINI AND V_CDCONTFIM
                      AND C.IDCONTCCUS <> 'R'
                      AND C.IDTIPOCONT = 'A'
                    GROUP BY C.CDCONTCTBL, I.DTIMPSALDO, VRIMPSALDO) X
            WHERE MENOR_DATA IS NOT NULL
               OR DTIMPSALDO IS NOT NULL
            ORDER BY 1) LOOP
          /* SE A VARIAVEL DE DATA DE IMPLANTACAO ESTIVER NULA  PORQUE NO TEVE IMPLANTAO, SENDO ASSIM,
              PRECISO SOMAR OS LANAMENTOS CONTBEIS E SOM-LOS AO SALDO J EXISTENTE */
          IF ATUALIZA.DTIMPSALDO IS NULL THEN
             DATA_SALDO := ATUALIZA.MENOR_DATA;
             DATA_SALDO := LAST_DAY(DATA_SALDO);

             V_CONTSALDO := 0;
             BEGIN
                SELECT COUNT(*)
                  INTO V_CONTSALDO
                  FROM SALDEMPR
                 WHERE (SALDEMPR.CDEMPRESA  = P_CDEMPRESA)
                   AND (SALDEMPR.CDCONTCTBL = ATUALIZA.CDCONTCTBL)
                   AND (SALDEMPR.DTSALDEMPR = DATA_SALDO);
             EXCEPTION
                WHEN NO_DATA_FOUND THEN
                   V_CONTSALDO := 0;
             END;
             IF (V_CONTSALDO = 0) THEN
                WHILE (DATA_SALDO <= MES.ULTIMODIA) LOOP
                   INSERT INTO SALDEMPR
                      (CDEMPRESA, CDCONTCTBL, DTSALDEMPR, VRSALDEMPR)
                   (SELECT P_CDEMPRESA, CDCONTCTBL, DATA_SALDO, 0
                      FROM CONTCTBL C
                     WHERE NOT EXISTS (SELECT 1
                                         FROM SALDEMPR S
                                        WHERE C.CDCONTCTBL = S.CDCONTCTBL
                                          AND CDEMPRESA = P_CDEMPRESA
                                          AND DTSALDEMPR = DATA_SALDO)
                       AND (INSTR(ATUALIZA.CDCONTCTBL,RTRIM(C.CDCONTCTBL)) = 1));
                   V_CONTCOMMIT := V_CONTCOMMIT +1 ;
                   IF V_CONTCOMMIT = V_DARCOMMIT THEN
                      V_CONTCOMMIT := 1;
                      COMMIT;
                   END IF;
                   DATA_SALDO := ADD_MONTHS(DATA_SALDO,1);
                END LOOP;
             END IF;
             DATA_SALDO := ATUALIZA.MENOR_DATA;
             DATA_SALDO := LAST_DAY(DATA_SALDO);

             WHILE (DATA_SALDO <= MES.ULTIMODIA) LOOP
                FOR SOMACONTA IN
                   (SELECT CDCONTCTBL, SUM(ROUND(LANCCONT.VRLANCAMENT,2)) AS VALORSALDO
                      FROM LANCCONT
                     WHERE (LANCCONT.DTLANCCONT BETWEEN ATUALIZA.MENOR_DATA AND DATA_SALDO)
                       AND (LANCCONT.CDCONTCTBL = ATUALIZA.CDCONTCTBL)
                       AND (LANCCONT.CDEMPRESA  = P_CDEMPRESA)
                       AND IDLANCINTE <> 'S'
                     GROUP BY LANCCONT.CDCONTCTBL) LOOP

                   UPDATE SALDEMPR
                      SET VRSALDEMPR = SALDEMPR.VRSALDEMPR + SOMACONTA.VALORSALDO
                    WHERE (SALDEMPR.CDEMPRESA  = P_CDEMPRESA)
                      AND (SALDEMPR.DTSALDEMPR = DATA_SALDO)
                      AND (INSTR(SOMACONTA.CDCONTCTBL,RTRIM(SALDEMPR.CDCONTCTBL)) = 1);
                   V_CONTCOMMIT := V_CONTCOMMIT +1 ;
                   IF V_CONTCOMMIT = V_DARCOMMIT THEN
                      V_CONTCOMMIT := 1;
                      COMMIT;
                   END IF;
                END LOOP;
                DATA_SALDO := ADD_MONTHS(DATA_SALDO,1);
             END LOOP;
          ELSE
             /* CASO SEJA UM MS QUE TEVE IMPLANTAO DE SALDO,  PRECISO ATUALIZAR O SALDO
                DA CONTA CONTBIL E RECALCULAR AS CONTAS SINTTICAS */
             V_COUNT := 0;
             BEGIN
                SELECT COUNT(*)
                  INTO V_COUNT
                  FROM SALDEMPR
                 WHERE DTSALDEMPR = ATUALIZA.DTIMPSALDO
                   AND CDCONTCTBL = ATUALIZA.CDCONTCTBL
                   AND CDEMPRESA = P_CDEMPRESA;
             EXCEPTION
                WHEN NO_DATA_FOUND THEN
                   V_COUNT := 0;
             END;

             /* VERIFICA SE J EXISTE UM SALDO NO MS, PARA INSERIR OU ALTER-LO */
             IF V_COUNT <> 0 THEN
                UPDATE SALDEMPR
                   SET VRSALDEMPR = ATUALIZA.VRIMPSALDO
                 WHERE DTSALDEMPR = ATUALIZA.DTIMPSALDO
                   AND CDCONTCTBL = ATUALIZA.CDCONTCTBL
                   AND CDEMPRESA = P_CDEMPRESA;
             ELSE
                INSERT INTO SALDEMPR
                   (CDEMPRESA, DTSALDEMPR, CDCONTCTBL, VRSALDEMPR)
                VALUES
                   (P_CDEMPRESA, ATUALIZA.DTIMPSALDO, ATUALIZA.CDCONTCTBL, ATUALIZA.VRIMPSALDO);
             END IF;
             V_CONTCOMMIT := V_CONTCOMMIT +1 ;
             IF V_CONTCOMMIT = V_DARCOMMIT THEN
                V_CONTCOMMIT := 1;
                COMMIT;
             END IF;

             /* SE EXISTIR ALGUMA CONTA SINTTICA QUE CONTM ALGUMA CONTA ANALTICA QUE TEVE IMPLANTAO
                DE SALDO, MAS ELA AINDA NO EST INSERIDA NA SALDEMPR, ELA SER INCLUDA E TER O SALDO ATUALIZADO
                MAIS ABAIXO */
             FOR C_SINT_INSERE IN
                (SELECT C.CDCONTCTBL
                   FROM CONTCTBL C
                  WHERE ATUALIZA.CDCONTCTBL LIKE C.CDCONTCTBL ||'%'
                    AND C.IDTIPOCONT = 'S'
                    AND NOT EXISTS (SELECT 1
                                      FROM SALDEMPR S
                                     WHERE S.CDCONTCTBL = C.CDCONTCTBL
                                       AND S.CDEMPRESA = P_CDEMPRESA
                                       AND S.DTSALDEMPR = ATUALIZA.DTIMPSALDO)
                  ORDER BY 1) LOOP
                INSERT INTO SALDEMPR
                   (CDEMPRESA, DTSALDEMPR, CDCONTCTBL, VRSALDEMPR)
                VALUES
                   (P_CDEMPRESA, ATUALIZA.DTIMPSALDO, C_SINT_INSERE.CDCONTCTBL, 0);
                V_CONTCOMMIT := V_CONTCOMMIT +1 ;
                IF V_CONTCOMMIT = V_DARCOMMIT THEN
                   V_CONTCOMMIT := 1;
                   COMMIT;
                END IF;
             END LOOP;

             /* ATUALIZA OS VALORES DAS CONTAS SINTTICAS */
             FOR C_SINT_ATUALIZA IN
                (SELECT C.CDCONTCTBL
                   FROM CONTCTBL C
                  WHERE ATUALIZA.CDCONTCTBL LIKE C.CDCONTCTBL ||'%'
                    AND C.IDTIPOCONT = 'S') LOOP
                V_VRSALDO := 0;

                /* SOMA OS SALDOS DAS CONTAS ANALTICAS ABAIXO DA CONTA SINTTICA */
                BEGIN
                   SELECT SUM(ROUND(VRSALDEMPR, 2))
                     INTO V_VRSALDO
                     FROM SALDEMPR S, CONTCTBL C
                    WHERE S.CDEMPRESA = P_CDEMPRESA
                      AND S.DTSALDEMPR = ATUALIZA.DTIMPSALDO
                      AND S.CDCONTCTBL LIKE C_SINT_ATUALIZA.CDCONTCTBL || '%'
                      AND S.CDCONTCTBL = C.CDCONTCTBL
                      AND C.IDTIPOCONT = 'A';
                EXCEPTION
                   WHEN NO_DATA_FOUND THEN
                      V_VRSALDO :=  0;
                END;

                /* ATUALIZA O SALDO DA CONTA SINTTICA */
                UPDATE SALDEMPR
                   SET VRSALDEMPR = V_VRSALDO
                 WHERE CDCONTCTBL =  C_SINT_ATUALIZA.CDCONTCTBL
                   AND CDEMPRESA = P_CDEMPRESA
                   AND DTSALDEMPR = ATUALIZA.DTIMPSALDO;
                V_CONTCOMMIT := V_CONTCOMMIT +1 ;
                IF V_CONTCOMMIT = V_DARCOMMIT THEN
                   V_CONTCOMMIT := 1;
                   COMMIT;
                END IF; 
             END LOOP;
          END IF;
       END LOOP;

       /* ATUALIZA SALDOS ANTES DOS ENCERRAMENTOS */
       FOR SALDO IN(
          SELECT L.CDCONTCTBL, LAST_DAY(L.DTLANCCONT) DTLANCCONT
            FROM LANCCONT L, CONTCTBL C
           WHERE L.CDEMPRESA  = P_CDEMPRESA
             AND L.IDLANCINTE = 'F'
             AND L.DTLANCCONT  BETWEEN MES.PRIMDIA AND MES.ULTIMODIA
             AND (L.CDCONTCTBL BETWEEN V_CDCONTINI AND V_CDCONTFIM)
             AND L.CDCONTCTBL = C.CDCONTCTBL
             AND C.IDCONTCCUS <> 'R'
          GROUP BY L.CDCONTCTBL, LAST_DAY(L.DTLANCCONT)
          ORDER BY 2, 1) LOOP

          BEGIN
             SELECT SUM(NVL(VRLANCAMENT, 0)) AS VRLANCAMENT
               INTO V_VRSALDO
               FROM LANCCONT
              WHERE CDEMPRESA  = P_CDEMPRESA
                AND IDLANCINTE NOT IN ('F', 'S')
                AND CDCONTCTBL = SALDO.CDCONTCTBL
                AND DTLANCCONT BETWEEN MES.PRIMDIA AND MES.ULTIMODIA;
          EXCEPTION
             WHEN NO_DATA_FOUND THEN
                V_VRSALDO := 0;
          END;

          BEGIN
             SELECT NVL(SA.VRSALDEMPR, 0)
               INTO V_VRSALDEMPR
               FROM SALDEMPR SA
              WHERE SA.CDEMPRESA  = P_CDEMPRESA
                AND SA.CDCONTCTBL = SALDO.CDCONTCTBL
                AND SA.DTSALDEMPR = ADD_MONTHS(SALDO.DTLANCCONT,-1);
          EXCEPTION
             WHEN NO_DATA_FOUND THEN
                V_VRSALDEMPR := 0;
          END;

          V_VRSALDO := NVL(V_VRSALDO, 0) + NVL(V_VRSALDEMPR, 0);

          IF V_VRSALDO <> 0 THEN
             INSERT INTO SALDOTRANSF
               (CDEMPRESA, CDCONTCTBL, DTSALDOTRANSF, VRSALDOTRANSF)
             VALUES
               (P_CDEMPRESA, SALDO.CDCONTCTBL, SALDO.DTLANCCONT, NVL(V_VRSALDO, 0));
          END IF;
       END LOOP;

       FOR ATUALIZA IN
          (SELECT DISTINCT LANCCONT.CDCONTCTBL, LAST_DAY(DTLANCCONT) AS DTLANCCONT
             FROM LANCCONT, CONTCTBL
            WHERE (LANCCONT.CDEMPRESA   = P_CDEMPRESA)
              AND (LANCCONT.DTLANCCONT >= MES.PRIMDIA)
              AND (LANCCONT.CDCONTCTBL BETWEEN V_CDCONTINI AND V_CDCONTFIM)
              AND (LANCCONT.CDCONTCTBL = CONTCTBL.CDCONTCTBL)
              AND (CONTCTBL.IDCONTCCUS <> 'R')
              AND (LANCCONT.IDLANCINTE = 'F')
            ORDER BY 2, 1) LOOP

          SELECT NVL(SUM(VRLANCAMENT), 0)
            INTO V_VRSALDO
            FROM LANCCONT
           WHERE TO_CHAR(DTLANCCONT, 'MM/YYYY') = TO_CHAR(ATUALIZA.DTLANCCONT, 'MM/YYYY')
             AND CDEMPRESA  = P_CDEMPRESA
             AND CDCONTCTBL = ATUALIZA.CDCONTCTBL
             AND IDLANCINTE NOT IN ('F', 'S');

          SELECT TRUNC(MIN(DTLANCCONT))
            INTO MENOR_DATA
            FROM LANCCONT
           WHERE (LANCCONT.CDEMPRESA   = P_CDEMPRESA)
             AND (LANCCONT.DTLANCCONT >= MES.PRIMDIA)
             AND (LANCCONT.CDCONTCTBL = ATUALIZA.CDCONTCTBL);

          DATA_SALDO := LAST_DAY(MENOR_DATA);

          WHILE (DATA_SALDO <= MES.ULTIMODIA) LOOP
             INSERT INTO SALDOTRANSF
                (CDEMPRESA, CDCONTCTBL, DTSALDOTRANSF, VRSALDOTRANSF)
                (SELECT P_CDEMPRESA, CDCONTCTBL, DATA_SALDO, V_VRSALDO
                   FROM CONTCTBL
                  WHERE (CDCONTCTBL NOT IN (SELECT DISTINCT CDCONTCTBL
                                              FROM SALDOTRANSF
                                             WHERE ((CDEMPRESA    = P_CDEMPRESA)
                                               AND (DTSALDOTRANSF = DATA_SALDO))))
                    AND (INSTR(ATUALIZA.CDCONTCTBL, RTRIM(CONTCTBL.CDCONTCTBL)) = 1));

             V_CONTCOMMIT := V_CONTCOMMIT +1 ;
             IF V_CONTCOMMIT = V_DARCOMMIT THEN
                V_CONTCOMMIT := 1;
                COMMIT;
             END IF;
             DATA_SALDO := ADD_MONTHS(DATA_SALDO,1);
          END LOOP;
       END LOOP;

       /* ATUALIZA OS VALORES DE TRANSFERNCIA PARA CONTAS CONTBEIS SINTTICAS */
       /* TRAZ OS VALORES DAS CONTAS CONTBEIS E AS PRPRIAS CONTAS A PARTIR DA DATA INICIAL */
       FOR SALDO_SINTETICO IN
          (SELECT VRSALDOTRANSF, DTSALDOTRANSF, S.CDCONTCTBL
             FROM SALDOTRANSF S, CONTCTBL C
            WHERE S.CDEMPRESA = P_CDEMPRESA
              AND S.DTSALDOTRANSF >= MES.PRIMDIA
              AND S.CDCONTCTBL BETWEEN V_CDCONTINI AND V_CDCONTFIM
              AND S.CDCONTCTBL = C.CDCONTCTBL
              and C.IDCONTCCUS <> 'R'
              AND C.IDTIPOCONT = 'S'
            ORDER BY 2, 3) LOOP

          DATA_SALDO := LAST_DAY(SALDO_SINTETICO.DTSALDOTRANSF);

          WHILE (DATA_SALDO <= MES.ULTIMODIA) LOOP
          /*TRAZ OS SALDOS DOS MESES ANTERIORES S TRANSFERNCIAS */
             BEGIN
                SELECT NVL(VRSALDEMPR, 0)
                  INTO V_VRSALDEMPR
                  FROM SALDEMPR S
                 WHERE S.CDEMPRESA  = P_CDEMPRESA
                   AND S.CDCONTCTBL = SALDO_SINTETICO.CDCONTCTBL
                   AND S.DTSALDEMPR = ADD_MONTHS(SALDO_SINTETICO.DTSALDOTRANSF, -1);
              EXCEPTION
                 WHEN NO_DATA_FOUND THEN
                    V_VRSALDEMPR := 0;
              END;

              BEGIN
                SELECT NVL(SUM(VRLANCAMENT), 0)
                  INTO V_VRSALDO
                  FROM LANCCONT L, CONTCTBL C
                 WHERE L.CDEMPRESA  = P_CDEMPRESA
                   AND L.CDCONTCTBL LIKE SALDO_SINTETICO.CDCONTCTBL || '%'
                   AND TO_CHAR(L.DTLANCCONT, 'MM/YYYY') = TO_CHAR(SALDO_SINTETICO.DTSALDOTRANSF, 'MM/YYYY')
                   AND L.CDCONTCTBL = C.CDCONTCTBL
                   AND L.IDLANCINTE NOT IN ('F', 'S')
                   AND C.IDCONTCCUS <> 'R'
                   AND C.IDTIPOCONT = 'A';
              EXCEPTION
                 WHEN NO_DATA_FOUND THEN
                    V_VRSALDO := 0;
              END;

           /* ATUALIZA O SALDO DA CONTA SOMANDO O VALOR ANTERIOR DA SALDEMPR MAIS
              OS VALORES DOS LANAMENTOS DO MS, ESTES VALORES J ESTO GRAVADOS NA TABELA */
             UPDATE SALDOTRANSF
                SET VRSALDOTRANSF = V_VRSALDEMPR + V_VRSALDO
              WHERE DTSALDOTRANSF = DATA_SALDO
                AND CDEMPRESA     = P_CDEMPRESA
                AND CDCONTCTBL    = SALDO_SINTETICO.CDCONTCTBL;
             V_CONTCOMMIT := V_CONTCOMMIT +1 ;
             IF V_CONTCOMMIT = V_DARCOMMIT THEN
                V_CONTCOMMIT := 1;
                COMMIT;
             END IF;
             DATA_SALDO := ADD_MONTHS(DATA_SALDO, 1);
          END LOOP;
       END LOOP;
       UPDATE LANCCONT
          SET IDLANCSALDO = 'S'
        WHERE (CDEMPRESA = P_CDEMPRESA)
          AND (DTLANCCONT BETWEEN MES.PRIMDIA AND MES.ULTIMODIA)
          AND (IDLANCSALDO = 'N');
       COMMIT;
    END LOOP;
    COMMIT;
    IF P_CALCSOC = 'S' THEN
       V_UTSALDOSOC := 'N';
       BEGIN
          SELECT IDUTSALDOSOC
            INTO V_UTSALDOSOC
            FROM CONTOPECTBL
           WHERE CDEMPRESA = P_CDEMPRESA;
       EXCEPTION
          WHEN NO_DATA_FOUND THEN
             V_UTSALDOSOC := 'N';
       END;
       IF V_UTSALDOSOC = 'S' THEN
          ATUALIZA_SALDO_SOC(P_CDEMPRESA, P_CDCONTINI, P_CDCONTFIN, P_DATAINIC, V_DTFINACONT);
       END IF;
    END IF;
END;
/