function Est11000_EntradaEstoque_Controller($rootScope, ScreenService, General, templateManager, Est11000_EntradaEstoque_Service, ValidacoesEstoque_Service, Lib00206_InfComplProduto_Controller, ZHPromise, metaDataFactory, ZhFilterPreferences, MessageService, EstUtil) {

	this.cdTipCustEst = 3;
	this.filialctrlestoq = 'S';
	var nrorg;
	var paramEstoq;
	var cdtpoper = "10";
	var identrsaidop = "E";
	var idutilalmox;
	var idutillcestq;
	var idutillote;	
	var datasetBkp = [];
	
	/**
	 * Essa função tem como objetivo executar a função do botão de voltar da tela. Quando em modo de
	 * inserir retirada ele roda o data da widget para achar qual posição estava sendo editada/inserida.
	 * Quando encontrado, seta a currentRow e a posição no data com o backup feito na função do modo
	 * de edição, troca a editabilidade de alguns campos e passa a widget para o modo view.
	 * Quando o registro esta sendo inserido, ainda no modo inserir retirada, a posição do data é
	 * retirada.
	 * Quando não está no modo de inserir uma retirada, chama função do General que cancela a edição
	 * ou inserção.
	 *
	 * @param args | evento da action
	 */
	this.backEditItens = function(args) {
		var widget = args.owner.widget;
		if (widget.call === 'insertRetirada' && !widget.currentRow.novo) {
			widget.dataSource.data.forEach(function(row, rowIndex, rows) {
				if (widget.currentRow === row) {
					rows[rowIndex] = widget.backupRow;
					widget.currentRow = widget.backupRow;

					//this.changeReadOnlyByName(widget, 'QTTOTLANCTO', true);
					//this.changeReadOnlyByName(widget, 'QTDEVOLESTOQ', true);

					widget.view();
				}
			}.bind(this));
		}
		
		else {
			General.backOrCancel(args);
		}
	};

	/**
	 * Essa função tem como finalidade verificar o valor do campo de produto na inserção
	 * de um item na retirada. Quando tem valor chama a Lib que abre o popup de Informações
	 * Complementares de Produto e na sequência permite que outros campos sejam editavéis.
	 * Caso o campo não tenha valor, os campos, antes habilitados, são desabilitados para
	 * edição. Depois os valores dos campos que aparecem na tela são zerados.
	 *
	 * @param widget | widget de itens da retirada
	 */
	this.callInformacoesComplmentares = function(widget) {
		var promise = ZHPromise.defer();
		if (widget.currentRow.CDARVPROD) {
			widget.promise = promise;
			let widgetEntrada = widget.container.getWidget('entrada');
			let filterRow = isset(() => widgetEntrada.appliedFilter.FILTER_ROW) ? widgetEntrada.appliedFilter.FILTER_ROW : false;
			if (isset(() => filterRow.CDALMOXARIFE)) {
				if (filterRow.CDALMOXARIFE != ' ')
					widget.currentRow.CDALMOXARIFE = filterRow.CDALMOXARIFE;
			}
			if (isset(() => filterRow.CDLOCALESTOQ)) {
				if (filterRow.CDLOCALESTOQ != ' ')
					widget.currentRow.CDLOCALESTOQ = filterRow.CDLOCALESTOQ;
			}
			Lib00206_InfComplProduto_Controller.infComplementares(widget, widget.currentRow);
		}
		else {
			promise.reject();
		}
		return promise;
	};

	/**
	 * Essa função tem como finalidade carregar a widget de itens da retirada, e setar na
	 * widget de retirada o campo de Tipo de Retirada, colocando na currentRow no código
	 * e nome do tipo de retirada.
	 *
	 * @param widget | widget de retirada
	 */
	this.carregaItems = function(widget) {
		var widgetItens = widget.widgets[0];
		if (!widget.currentRow.__is_new) {
			widgetItens.reload().then(function() {
				widget.currentRow.CDTIPORETI = widgetItens.dataSource.data[0].CDTIPORETI;
				widget.currentRow.NMTIPORETI = widgetItens.dataSource.data[0].NMTIPORETI;
			});
		}
		else {
			widgetItens.dataSource.data = [];
		}
	};

	/**
	 * Essa função tem como finalidade percorrer o filtro montado pelo ZhFilter. É verificado
	 * se o usuario selecinou almoxarifado e/ou localização, se não tiver selecionado é
	 * inserido no filtro almoxarifado e/ou localizacao com o valor de T para aquele que não
	 * foi selecionado no filtro. É verificado também, se o filtro recebeu data, se não tiver
	 * recebido é passado no filtro DATA o valor T, se tiver recebido é passado NULL.
	 *
	 * @param widget | widget com name de "retirada"
	 */
	this.changeFilter = function(widget, preference) {
		/*	var filterRow = preference.FILTER_ROW;
		var filterData;
		var dtinicial, dtfinal, data, cdalmoxar, cdlocal;
		let actAdicionar = widget.getAction('adicionar');
		actAdicionar.isVisible = this.filialctrlestoq == 'S'? true: false;
		
		if(filterRow.DTINICIAL && filterRow.DTFINAL){
			dtinicial = filterRow.DTINICIAL;
			dtfinal = filterRow.DTFINAL;
			data = null;
		} else {
			dtinicial = null;
			dtfinal = null;
			data = 'T';
		}
		if(filterRow.ALMOXARIFE && (filterRow.ALMOXARIFE != "")){
			cdalmoxar = filterRow.ALMOXARIFE;
		} else {
			cdalmoxar = 'T';
		}
		if(filterRow.CDLOCALESTOQ && (filterRow.CDLOCALESTOQ != "")){
			cdlocal = filterRow.CDLOCALESTOQ;
		} else {
			cdlocal = 'T';
		}
        var filter = [
        	{
                "name":"CDFILIAL",
                "operator":"=",
                "value": filterRow.CDFILIAL
            },
            {
                "name":"CDALMOXARIFE",
                "operator":"=",
                "value": cdalmoxar
            },
            {
                "name":"CDLOCALESTOQ",
                "operator":"=",
                "value": cdlocal
            },
            {
                "name":"DTINICIAL",
                "operator":"=",
                "value": dtinicial
            },
            {
                "name":"DTFINAL",
                "operator":"=",
                "value": dtfinal
            },
            {
                "name":"DATA",
                "operator":"=",
                "value": data
            }
        ];
		//filter.push(filterData[0]);
        widget.dataSourceFilter = filter;
		widget.reload();*/
	};

	/**
	 * A função tem a finalidade de trocar as propriedades label, hideicon e isvisible
	 * de uma action que será selecionada pelo seu nome.
	 *
	 * @param data | array de objetos (as actions)
	 * @param label | string com o novo valor da propriedade label
	 * @param hide | boolean com o valor para setar a propridade hideIcon
	 * @param name | string com o nome da action que vai ser alterada
	 * @param visibility | boolean para setar a visibilidade de action
	 */
	this.changeHideInconLabelVisible = function(data, label, hide, name, visibility) {
		data.forEach(function(element) {
			if (element.name === name) {
				element.label = label;
				element.hideIcon = hide;
				element.isVisible = visibility;
			}
		});
	};

	/**
	 * Essa função tem como finalidade trocar o valor da propriedade readOnly
	 * de um field de uma widget.
	 *
	 * @param widget | widget onde sera pego o campo.
	 * @param name | nome do field que vai ser pegado da widget e alterado a propriedade
	 * @param read | true ou false para habilitar ou não a propriedade
	 */
	this.changeReadOnlyByName = function(widget, name, read) {
		widget.getField(name).readOnly = read;
	};

	/**
	 * Essa função tem como finalidade controlar as validações do campo de campo de
	 * localização chegando se a unidade do filtro controla localização de almoxarifado
	 * e se o campo de almoxarifado está preenchido. Se ambos forem verdadeiros, habilita
	 * o campo, se não desabilita o campo e limpa a currentRow dos dados de localização
	 *
	 * @param widget | widget do filtro
	 */
	this.changeReadOnlyLocal = function(widget) {
		var almox = widget.currentRow.CDALMOXARIFE;
		var flocal = widget.getField('DSLOCALESTOQ');
		if (almox && Est11000_EntradaEstoque_Service.utilizaLocalizacao()) {
			flocal.readOnly = false;
			flocal.reload();
		}
		else {
			widget.currentRow.CDLOCALESTOQ = null;
			widget.currentRow.DSLOCALESTOQ = null;
			flocal.readOnly = true;
		}
	};

	/**
	 * Essa função tem a finalidade de voltar as actions para o estado normal depois
	 * de cancelar a inserção de uma retirada sem requisição.
	 *
	 * @param args | evento da action
	 */
	this.checkBackAction = function(args) {
		var widget = args.owner.widget;
		let tabbedWidget = templateManager.container.getWidget('entradaTabbed');
		let widgetPrincipal = templateManager.container.getWidget('entrada');
		let widgetGridItens = templateManager.container.getWidget('itens');

		if (tabbedWidget.currentRow.__is_new) {
			widgetPrincipal.dataSource.data.pop();
			tabbedWidget.currentRow = {};
			widgetPrincipal.currentRow = {};
			ScreenService.goBack();
		}
		else {
			if (widgetPrincipal.dataSource.data[widgetPrincipal.dataSource.data.length - 1].__is_new)
				widgetPrincipal.dataSource.data.pop();

			ScreenService.goBack();
		}

		if (tabbedWidget.currentRow.changed) {
			tabbedWidget.currentRow.changed = false;
		}


	};

	/**
	 * Essa função tem a finalidade de verificar se existe algum produto que ainda não teve
	 * suas informações complementares colocadas e está sendo salvo. Se isso acontecer, dá uma
	 * mensagem ao usuário e retorna false para a função que lhe chamou.
	 *
	 *	@param data | data da widget de itens
	 */
	this.checkProdutosCompletos = function(data) {
		var validação = true;
		data.forEach(function(produto) {
			if (produto.COMPLETO !== 'S') {
				validação = false;

				// ScreenService.showMessage('Não é possível salvar pois faltam informações para o produto ' + produto.NMPRODUTO + '.');

				/* MSG NOVA */
				var variaveis = {
					NMPRODUTO: produto.NMPRODUTO
				};

				MessageService.showMessageByCode("PRODUTOIRREGULAR", variaveis);
				/* FIM MSG NOVA */

			}
		});
		return validação;
	};

	this.checkRequisicaoComplementarCreation = function(widget) {
		var promise = ZHPromise.defer();
		var item = widget.currentRow;

		if (this.checkShouldCreateRequisicaoComplementar(item)) {
			var msg = "Quantidade requisitada não disponível em estoque para o produto " + item.NMPRODUTO + " : " + item.QTESTOQDIA + " " + item.SGUNIDADE + ". Deseja gerar uma requisição complementar?";

			ScreenService.confirmMessage(msg,
				'question',
				function() { //sim
					item.createReqComp = true;
					item.QTLANCREQCOMP = item.QTREQUESTO - item.QTESTOQDIA;

					promise.resolve();
				}.bind(this),
				function() { //não
					item.createReqComp = false;

					promise.resolve();
				}.bind(this));
		}
		else promise.resolve();

		return promise;
	};

	this.checkShouldCreateRequisicaoComplementar = function(item) {
		return item.NRREQUESTO && item.IDREQCOMPEST == 'S' &&
			item.QTESTOQDIA == item.QTLANCTOEST &&
			item.QTESTOQDIA < item.QTREQUESTO;
	};

	/**
	 * Essa função tem como finalidade controlar em qual estado o usuário esta usando a tela
	 * e chamar a função correspondente ao estado que ela está.
	 *
	 * @param widget | widget de retirada
	 */
	this.checkSaveMod = function(widget) {
		if (widget.isValid()) {
			if (widget.currentRow.__is_new && widget.currentRow.NRREQUESTO) {
				widget.enabled = false;
				this.getItensOfRequisicao(widget.widgets[0], widget.currentRow.CDFILIAL, widget.currentRow.NRREQUESTO);
				this.focusAddProduto(widget.widgets[0]);
			}
			else if (widget.currentRow.__is_new) {
				widget.enabled = false;
				this.focusAddProduto(widget.widgets[0]);
			}
			else if (!widget.currentRow.__is_new) {
				this.saveEditRetirada(widget);
			}
		}
	};

	/**
	 * Essa função tem como finalidade limpar alguns dados da currentRow quando o produto mudar
	 * (inserindo um produto em uma retirada que está sendo inserida). Qunado troca-se o produto,
	 * só os capos de valor são alterados, quando o valor do campo é null, é passado true para
	 * clearAll e valores relacionados ao produto são limpados também.
	 *
	 * @param widget | widget de itens
	 * @param clearAll | parametro para lipar ou não todos os capos da currentRow
	 */
	this.clearRowItens = function(widget, clearAll) {
		if (widget.currentRow.COMPLETO === 'S') {
			widget.currentRow.QTREQUESTO = "";
			widget.currentRow.QTTOTLANCTO = "";
			widget.currentRow.QTDEVOLESTOQ = "";
			widget.currentRow.QTLANCTOEST = "";
			widget.currentRow.VRTOTLANCTO = "";
			if (clearAll) {
				widget.currentRow.NMPRODUTO = "";
				widget.currentRow.CDARVPROD = "";
				widget.currentRow.SGUNIDADE = "";
				widget.currentRow.VRUNILANCTO = "";
			}
		}
	};

	/**
	 * Essa função tem como finalidede clonar todos os dados do dataSource da widget, de
	 * itens principalmente. Não clonando escopos das actions que podem estar na row da
	 * widget.
	 *
	 * @param data | array de objetos; dataSource.data da widget
	 * @return arrray | array de objetos clonados do data da widget
	 */
	this.copyDataWidgetItens = function(data) {
		var copy = [];
		data.forEach(function(item) {
			copy.push(Util.clone(item, ['__rightActions', '__leftActions']));
		});
		return copy;
	};

	/**
	 * Essa função tem a finalidade verificar em qual modo está sendo chamado a função de excluir um
	 * item da retirada. Conforme o modo, chama a função respectiva.
	 *
	 * @param widget | widget de itens
	 */
	this.deleteItem = function(args) {
		let widget = args.owner.widget;
		let widgetTabbed = templateManager.container.getWidget('entradaTabbed');
		let bloqEdit = validaLançamentoDeIntegracaoes(widgetTabbed.currentRow, args);
		if (!bloqEdit) {
			this.removeItemEntrada(args);
		}
	};

	/**
	 * Inicialmente a função verifica se aquela retirada pode ser editada (inserir/excliuir/editar um
	 * item é editar uma retirada), se não puder é dada uma mesagem para o usuario. Se puder ser editado
	 * a currentRow é clonada (não é clonada __rightActions e __leftActions pois são escopos), a widget é
	 * colocado em modo de edição e a editabilidade de alguns campos é alterada
	 *
	 * @param widget | widget de itens
	 */
	this.editItens = function(args) {
		let widget = args.owner.widget;
		let widgetTabbed = templateManager.container.getWidget('entradaTabbed');
		let bloqEdit = validaLançamentoDeIntegracaoes(widgetTabbed.currentRow, args);

		if (!bloqEdit) {
			if (!widget.currentRow.NRORDPROD) {
				widget.backupRow = Util.clone(widget.currentRow, ['__rightActions', '__leftActions']);
				widget.edit();
			}
			//this.changeReadOnlyByName(widget, 'QTTOTLANCTO', false);
			//this.changeReadOnlyByName(widget, 'QTDEVOLESTOQ', false);
		}

	};

	/**
	 * Essa função tem como finalidade trocar o label do botão de salvar (para garantir que ficará
	 * com a label certa), colocar a widget em modo de edição e desabilitar a widget de produtos.
	 * Isso acontece ao acionar o botão de editar a retirada.
	 * Antes disso é verificado se a retirada pode ser editada, verificando os capos NRORDPROD e
	 * NRLANCESTRET, onde se um deles estiver preencido, é dado sua respctiva mensagem, impedindo
	 * o usuário de editar a retirada.
	 *
	 * @param widget | widget de retirada
	 */
	this.editRetirada = function(widget) {

		if (widget.currentRow.EXISTECONSUMO == "N") {
			if (!widget.currentRow.NRORDPROD) {
				if (!widget.currentRow.NRLANCESTRET) {
					General.edit(widget);
					this.enabledWidget(true);
				}
				else {
					ScreenService.showMessage("Operação bloqueada! Retirada oriunda de um ajuste de inventário.");
				}
			}
			else {
				ScreenService.showMessage("Operação bloqueada! Retirada gerada pela Ordem de Produção.");
			}
		}
		else {
			ScreenService.showMessage("Operação bloqueada! Não é possível editar pois existe um consumo.");
		}
	};

	/**
	 * Essa função tem como finalidade habilitar e desabilitar a widget "itens", onde
	 * são exibidos os produtos da retirada. Ela é a widget filha da widget "retirada".
	 *
	 * @param enabled | booleano para habilitar ou desabilitar a widget de itens
	 */
	this.enabledWidget = function(enabled) {
		var widget = templateManager.container.getWidget('itens');
		widget.enabled = enabled;
	};

	/**
	 * Essa função tem a finalidade de ativar a widget de produto, deixá-la ativa,
	 * setar uma propriedade de controle e mudar a configuração das actions para
	 * funcionarem no modo de inserir retirada sem requisição.
	 *
	 * @param widget | widget de itens
	 */
	this.focusAddProduto = function(widget) {
		this.enabledWidget(true);
		widget.call = 'insertRetirada';
		widget.activate();
		widget.floatingControl.refreshAction = false;
		this.changeHideInconLabelVisible(widget.actions, 'Cancelar', true, 'VoltarList', true);
		this.changeHideInconLabelVisible(widget.actions, 'Adicionar', true, 'salvar', true);
		this.changeHideInconLabelVisible(widget.actions, 'Salvar', true, 'salvarNaRetirada', true);
	};


	/**
	 * Essa função tem como finalidade consultar as parametrizações da filial selecionada
	 * no filtro, caso ainda não tenha sido selecionada nenhuma filial no filtro, é usado
	 * o valor FILIAL_LOGADA, que pegara o código da filial logada no backend. Se não
	 * retornar nenhum erro, chama uma função que vai setar valores default para outros
	 * campos do filtro.
	 *
	 * @param widget | widget
	 */
	this.getParamFilialOnce = function(widget) {
		this.setFieldsGerais(widget);
		var filterRow = {};
		this.getFilialLogada().then(function(success) {
			let returnedDataset = success.dataset.paramfilial_paramvalidacoes[0];
			nrorg = returnedDataset.NRORG;
			filterRow.CDFILIMOVI = returnedDataset.CDFILIAL;
			filterRow.NMFILIAL = returnedDataset.NMFILIAL;
			this.filialctrlestoq = returnedDataset.IDCTRLESTQ;
			idutilalmox = returnedDataset.IDUTILALMOX;
			idutillcestq = returnedDataset.IDUTILLCESTQ;
			idutillote = returnedDataset.IDUTILLOTE;

			if (returnedDataset.IDCTRLESTQ == 'N')
				ScreenService.showMessage('Filial logada não controla estoque.');

			ZhFilterPreferences.openFilterWidget(widget, filterRow).then(function() {
				var filial = filterRow.CDFILIMOVI || widget.currentRow.CDFILIMOVI || 'FILIAL_LOGADA';
				Est11000_EntradaEstoque_Service.getParamFilial(filial, true).then(function(succes) {
					let widgetFiltro = templateManager.container.getActiveWidget();
					if (succes) {
						this.setCampos(widgetFiltro, succes, filial);
					}
					else {
						ScreenService.showMessage(succes);
					}
				}.bind(this), function(error) {
					ScreenService.showMessage(error.data.error);
				});
			}.bind(this));
		}.bind(this));
	};

	this.getFilialLogada = function(filial = 'FILIAL_LOGADA') {
		var filter = [
			{
				"name": "CDFILIAL",
				"operator": "=",
				"value": filial
                }
		    ];
		return General.callRestEngine('est#/crud/paramfilial_paramvalidacoes', 'FilterData', filter);
	};

	this.setFieldsGerais = function(widget) {
		templateManager.container.fieldsGerais = widget.fields.map(function(field) { return field.name; });
	};

	this.getParamFilial = function(widget) {
		let widgetGridProdutos = widget.container.getWidget('itens');
		var filial = widget.currentRow.CDFILIMOVI;
		if (filial) {
			Est11000_EntradaEstoque_Service.getParamFilial(filial, true).then(function(succes) {
				if (succes) {
					let filialctrlestoq = succes.IDCTRLESTQ;
					if (filialctrlestoq == 'S' ? false : true)
						ScreenService.showMessage('Filial não Controla Estoque');
					if (succes.IDUTILLOTE == 'S')
						widgetGridProdutos.paramInfoCompl.ShowLote = true;
					else
						widgetGridProdutos.paramInfoCompl.ShowLote = false;

					this.setCampos(widget, succes, filial);
				}
				else {
					ScreenService.showMessage(succes);
				}
			}.bind(this), function(error) {
				ScreenService.showMessage(error.data.error);
			});
		}
	};

	/**
	 * Essa função tem como finalidade dar um newRow na widget de itens e com base nos
	 * dados que a mesma já tem, calcular qual será o próximo sequencial do item para
	 * aquela retirada de estoque.
	 * Antes disso é verificado se a retirada pode ser editada, verificando os capos NRORDPROD e
	 * NRLANCESTRET, onde se um deles estiver preencido, é dado sua respctiva mensagem, impedindo
	 * o usuário de editar a retirada.
	 *
	 * @param widget | widget de itens da retirada
	 */
	this.newItem = function(args) {
		let widget = args.owner.widget;
		let widgetTabbed = widget.container.getWidget('entradaTabbed');
		let bloqEdit = validaLançamentoDeIntegracaoes(widgetTabbed.currentRow, args);
		if (!bloqEdit) {
			widget.newRow();
			widget.currentRow.novo = true;
			widget.currentRow.CDFILIAL = widgetTabbed.currentRow.CDFILIAL;
			widget.currentRow.CDFILIMOVI = widgetTabbed.currentRow.CDFILIMOVI;
			widget.currentRow.NRLANCESTQ = widgetTabbed.currentRow.NRLANCESTQ;
			widget.currentRow.NRSEQUITEM = Est11000_EntradaEstoque_Service.geraNrsequitem(widget.dataSource.data);
			widget.currentRow.DTLANCMOVI = widget.getParent().currentRow.DTLANCESTQ.substr(0, 10);
			widgetTabbed.currentRow.CDTIPOOPER = cdtpoper;
			widgetTabbed.currentRow.IDENTRSAIDOP = identrsaidop;
		}
	};
	
	this.backupDataSet = function(args){
		var widget = args.owner;
		widget.dataSource.data = [...datasetBkp, ...widget.dataSource.data];
	};

	/**
	 * Essa função tem a finalidade de validar a relação entre os valores dos campos de valor
	 * na widget de itens.
	 *
	 * @param widget | widget de itens
	 */
	this.onChangeQt = function(widget) {
		var row = widget.currentRow;
		var calcTotValues = true,
			isValid = false;
		var permitEstoqNeg = widget.getParent().currentRow.idpermestneg;
		if (row.QTDEVOLESTOQ < 0) {
			row.QTDEVOLESTOQ = null;
			ScreenService.showMessage('A quantidade devolvida não pode ser menor que 0.');
		}
		else if (row.QTTOTLANCTO <= 0) {
			row.QTTOTLANCTO = null;
			ScreenService.showMessage('A quantidade retirada não pode ser menor ou igual a 0.');
		}
		else if (row.QTTOTLANCTO < row.QTDEVOLESTOQ) {
			row.QTDEVOLESTOQ = null;
			ScreenService.showMessage('A quantidade retirada não pode ser menor que a quantidade devolvida.');
		}
		else if (row.QTTOTLANCTO > row.QTESTOQDIA && permitEstoqNeg == 'N') {
			ScreenService.showMessage('Quantidade informada não disponível no estoque.');
			row.QTTOTLANCTO = null;
		}
		else if (row.QTTOTLANCTO === row.QTDEVOLESTOQ) {
			calcTotValues = false;
			ScreenService.confirmMessage('Quantidade movimentada igual a 0, portanto o item não realizará atualização de estoque. Confirmar operação?',
				'question',
				function() { //sim
					Est11000_EntradaEstoque_Service.setQtLanctoEst(row);
					Est11000_EntradaEstoque_Service.setVrTotLancto(row);
					Est11000_EntradaEstoque_Service.setVrlanctoest(row);

					this.checkSaveProduto(widget, true);
				}.bind(this),
				function() { //não
					row.QTDEVOLESTOQ = null;
					Est11000_EntradaEstoque_Service.setQtLanctoEst(row);
					Est11000_EntradaEstoque_Service.setVrTotLancto(row);
					Est11000_EntradaEstoque_Service.setVrlanctoest(row);
				});
		}
		else {
			isValid = true;
		}

		if (calcTotValues) {
			Est11000_EntradaEstoque_Service.setQtLanctoEst(row);
			Est11000_EntradaEstoque_Service.setVrTotLancto(row);
			Est11000_EntradaEstoque_Service.setVrlanctoest(row);
		}
		
		return isValid;
	};
	
	this.paramEstoq = function(nrorg) {
		var filter = [
			{
				"name": "NRORG",
				"operator": "=",
				"value": nrorg
                }
		    ];
		return General.callRestEngine('est#/paramestoque_geral', 'FilterData', filter);
	};
	
	this.sugestProductCosts = function(widget) {
		this.paramEstoq(nrorg).then(paramEstoq =>{
			ValidacoesEstoque_Service.consultaCustoQuantidadeProduto(
            	widget.currentRow.CDFILIMOVI,
            	widget.currentRow.CDPRODUTO,
            	widget.getParent().currentRow.DTLANCESTQ, //somente os 3 primeiros parametros sao obrigatórios
            	null, //tipocusto null para pegar do parametro de estoque
            	widget.currentRow.CDALMOXARIFE,
            	widget.currentRow.CDLOCALESTOQ,
            	widget.currentRow.NRLOTEESTQ,
        		widget.currentRow.NRSUBLOTE
        	).then((success) => {
            	if (success.dataset) {
            		if (paramEstoq.dataset.paramestoque_geral.IDSUGCUSENTR === "S"){
            			let custos = success.dataset.consultaCustoQuantidadeProduto;
            			if(custos.VRCUSTOPRODLIQ > 0 || custos.VRCUSTOPRODBRUT > 0){
	                		ScreenService.confirmMessage('Último custo de movimentação estoque: Líquido R$' + custos.VRCUSTOPRODLIQ.toFixed(5) + ' - Bruto R$' + custos.VRCUSTOPRODBRUT.toFixed(5) + '. Deseja utilizá-lo??', 'question', function() {
	                    		widget.currentRow.VRUNILANCTO = custos.VRCUSTOPRODLIQ;
	                    		widget.currentRow.VRUNITBRUT = custos.VRCUSTOPRODBRUT;
	                		}.bind(this));
            			}
            		}
                	
            	}
        	});
		});
    };

	this.openPosicaoDeEstoque = function(widget) {
		var popup = this.getPosicaoDeEstoquePopup(widget);

		ScreenService.openPopup(popup);

		popup.currentRow = widget.currentRow;
		popup.parentWidget = widget;

		this.getDataForPosicaoDeEstoquePopup(popup);
	};

	this.getDataForPosicaoDeEstoquePopup = function(popup) {
		Est11000_EntradaEstoque_Service.getPosicaoDeEstoquePorProduto(popup.currentRow).then(function(posestdia) {
			if (posestdia) {
				popup.currentRow = posestdia;
				let qtToSet = posestdia.QTESTOQDIA;
				if (qtToSet == 'undefined' || qtToSet == null)
					qtToSet = 0;
				popup.parentWidget.currentRow.QTESTOQDIA = qtToSet;
			}
			else {
				popup.currentRow.QTESTOQDIA = 0;
			}
		}).catch(function(error) {
			ScreenService.showMessage(error.data.error);
		});
	};

	this.getPosicaoDeEstoquePopup = function(parentWidget) {
		var widget = parentWidget.posestPopup;

		if (!widget) {
			widget = this.getPosicaoDeEstoquePopUpObject();
			widget.container = parentWidget.container;
			widget.label = widget.defaultLabel + parentWidget.currentRow.NMPRODUTO;

			widget = metaDataFactory.widgetFactory(widget, parentWidget);

			parentWidget.posestPopup = widget;
			widget.parent = parentWidget;
		}
		else
			widget.label = widget.defaultLabel + parentWidget.currentRow.NMPRODUTO;

		return widget;
	};

	this.getPosicaoDeEstoquePopUpObject = function() {
		return {
			"name": "posestPopup",
			"defaultLabel": "Posição de Estoque do Produto ",
			"template": "widget/form.html",
			"isVisible": true,
			"showAsTab": false,
			"actions": [
				{
					"name": "back",
					"label": "Voltar",
					"showAsAction": "back",
					"isVisible": true,
					"events": [
						{
							"name": "ActionEvent",
							"code": "ScreenService.closePopup()"
                        }
                    ]
                },
				{
					"name": "refresh",
					"label": "Atualizar",
					"showAsAction": "never",
					"isVisible": true,
					"events": [
						{
							"name": "ActionEvent",
							"code": "Est11000_EntradaEstoque_Controller.getDataForPosicaoDeEstoquePopup(args.owner.widget)"
                        }
                    ]
                }
            ],
			"fields": [
				{
					"name": "CDALMOXARIFE",
					"label": "Almoxarifado",
					"isVisible": true,
					"readOnly": true,
					"template": "field/text-edit.html",
					"class": 6,
					"showOnForm": true,
					"events": []
                },
				{
					"name": "CDLOCALESTOQ",
					"label": "Localização",
					"isVisible": true,
					"readOnly": true,
					"template": "field/text-edit.html",
					"class": 6,
					"showOnForm": true,
					"events": []
                },
				{
					"name": "NRLOTEESTQ",
					"label": "Lote",
					"isVisible": true,
					"readOnly": true,
					"template": "field/text-edit.html",
					"class": 6,
					"showOnForm": true,
					"events": []
                },
				{
					"name": "NRSUBLOTE",
					"label": "Sublote",
					"isVisible": true,
					"readOnly": true,
					"template": "field/text-edit.html",
					"class": 6,
					"showOnForm": true,
					"events": []
                },
				{
					"name": "QTESTOQDIA",
					"label": "Quantidade",
					"isVisible": true,
					"readOnly": true,
					"template": "field/text-edit.html",
					"class": 6,
					"showOnForm": true,
					"mask": {
                        "type": "viewFloat",
                        "params": {
                            "precision": 2,
                            "showSymbol": false
                        }
                    },
					"events": []
                },
				{
					"name": "DTVALILOTE",
					"label": "Data de Validade",
					"isVisible": true,
					"sequenceInForm": 80,
					"readOnly": true,
					"defaultValue": null,
					"template": "field/calendar.html",
					"dateFormat": "DD/MM/YYYY",
					"class": 6,
					"showOnForm": true,
					"events": []
                }
            ]
		};
	};

	/**
	 * Essa função tem a finalidade de ser executada quando o usuário quer remover um item de uma
	 * retirada que está sendo inserido, dessa forma é procurado em qual posição do data da widget
	 * está o item que o usuário quer retirar, e então é tirado do data da widget.
	 *
	 *	@param widget | widget de itens
	 */
	this.removeItemDataSource = function(widget) {
		var itens = widget.dataSource.data;
		for (var i = 0; i < itens.length; i++) {
			if (itens[i].CDARVPROD === widget.currentRow.CDARVPROD &&
				itens[i].CDALMOXARIFE === widget.currentRow.CDALMOXARIFE &&
				itens[i].CDLOCALESTOQ === widget.currentRow.CDLOCALESTOQ &&
				itens[i].NRLOTEESTQ === widget.currentRow.NRLOTEESTQ &&
				itens[i].NRSUBLOTE === widget.currentRow.NRSUBLOTE
			) {
				itens.splice(i, 1);
				i = itens.length;
				ScreenService.closeSwipe();
			}
		}
	};

	/**
	 * Inicialmente a função verifica se a retirada pode ser editada (inserir/excluir/editar um item
	 * é editar uma retirada), se tiver problema é dado uma mensagem na tela. Se tudo estiver certo,
	 * a função de excluir do General é chamada para excluir o item. Essa função é chamada quando
	 * se está excluindo um item de uma retirada que já existe.
	 *
	 * @param widget | widget de itens
	 */
	this.removeItemEntrada = function(args) {
		let widget = args.owner.widget;
		let widgetTabbed = templateManager.container.getWidget('entradaTabbed');
		let bloqEdit = validaLançamentoDeIntegracaoes(widgetTabbed.currentRow, args);
		if (!bloqEdit) {
			if (widget.dataSource.data.length > 1) {
				General.deleteCrud(widget);
			}
			else {
				ScreenService.showMessage("Operação bloqueada! Não é possível existir uma retirada sem item.");
			}
		}
	};

	/**
	 *
	 *
	 * @param widget | widget de retirada
	 */
	this.removeEntrada = function(args) {
		let widget = args.owner.widget;
		let widgetTabbed = templateManager.container.getWidget('entradaTabbed');
		let widgetPrincipal = templateManager.container.getWidget('entrada');
		let bloqEdit = validaLançamentoDeIntegracaoes(widgetTabbed.currentRow, args);

		if (!bloqEdit) {
			if (widget.currentRow.__is_new) {
				widget.dataSource.data = widget.dataSource.data.filter(row => {
					return row != widget.currentRow;
				});
				ScreenService.closeSwipe();
			}
			else {
				General.deleteCrud(widgetPrincipal);
			}
		}
	};

	/**
	 * Essa função tem como finalidade retornar todas as propriedades e labels de todas as widgets,
	 * para o estado normal da tela. Ela é chamado quando se termina ou cancela o processo de inserção
	 * de uma retirada.
	 *
	 * @param widget | widget de retirada
	 */
	this.returnStatus = function(widget) {
		//Mudanças na widget de Retirada para voltar ao estado de visualização
		widget.enabled = true;
		this.changeHideInconLabelVisible(widget.actions, 'Salvar', true, 'salvar', true);
		//Mudanças na widget de Itens para voltar ao estado de visualização
		var widgetItens = widget.widgets[0];
		widgetItens.enabled = true;
		this.changeHideInconLabelVisible(widgetItens.actions, 'Voltar', false, 'VoltarList', true);
		this.changeHideInconLabelVisible(widgetItens.actions, 'Salvar', true, 'salvarNaRetirada', false);
		widgetItens.floatingControl.refreshAction = true;
		widgetItens.call = 'padrão';
	};

	/**
	 * Essa função tem como finalidade salvar um produto novo em uma retirada já existente
	 * ou salvar a edição de um produto existente em uma retirada já existente. A função seta
	 * alguns campos da currentRow de itens com dados de referência da currentRow de retirada
	 * quando estiver inserindo um novo produto. Na sequência valida se essa operação não vai
	 * gerar estoque negativo e por fim chama a função de salvar do General.
	 *
	 */
	this.save = function(widgetRetirada) {
		var widgetItens = widgetRetirada.container.getWidget('itens');
		var itens = widgetItens.currentRow;
		var lancamento = widgetRetirada.currentRow;
		if (widgetItens.currentRow.__is_new) {
			itens.NRREQUESTO = lancamento.NRREQUESTO;
			itens.NRLANCESTQ = lancamento.NRLANCESTQ;
			itens.CDTIPORETI = lancamento.CDTIPORETI;
			itens.CDCENTCUST = lancamento.CDCENTCUST;
			itens.DTLANCMOVI = lancamento.DTLANCESTQ;
			itens.CDPRODMOVI = itens.CDPRODUTO;
			itens.IDUTILALMOX = idutilalmox;
			itens.IDUTILLCESTQ = idutillcestq;
			itens.IDUTILLOTE = idutillote;
		}
		General.saveCrud(widgetItens).then(() => {
			widgetRetirada.reload();
			this.carregaItems(widgetRetirada);
		});
	};

	/**
	 * Essa função tem a finalidade de executar os processos da edição de uma retirada. Chamando
	 * a função de salvar da widget, e no sucesso deixando a widget no modo view e dando reload
	 * na widget filha.
	 *
	 * @param widget | widget de retirada
	 */
	this.saveEditRetirada = function(widget) {
		//if(widget.isValid()) {
		widget.saveRow().then(function() {
			widget.view();
			widget.widgets[0].enabled = true;
			widget.widgets[0].reload();
		}, function(error) {
			ScreenService.showMessage(error.data.error);
		});
		//}
	};

	/**
	 * Essa função tem a finalidade de salvar a retirada e executar as mudanças na widget pós
	 * salvamento. Para salvar é necessário que existam itens sendo inseridos junto à retirada
	 * e que os itens que estão sendo inseridos estejam com as informações completas (passado
	 * pela tela Informações Complementares de Produto).
	 *
	 * @param widget | widget de itens
	 */
	this.saveNewEntrada = function(widget) {
		var widgetRetirada = widget.getParent();
		var itens = widget.dataSource.data;
		if (itens.length <= 0) {
			ScreenService.showMessage('É preciso adicionar itens à retirada para salva-la.');
		}
		else if (this.checkProdutosCompletos(itens)) {
			widgetRetirada.currentRow.ITENS = itens;
			ScreenService.showLoader();
			Est11000_EntradaEstoque_Service.saveRetirada(widgetRetirada.currentRow).then(function(sucess) {
				var lancamento = sucess.dataset.lancamento[0];
				var parentCurrentRowIndex = widget.getParent().dataSource.data.indexOf(widget.getParent().currentRow);

				this.returnStatus(widget.getParent());

				lancamento.NMFILIAL = widget.getParent().appliedFilter.FILTER_ROW.NMFILIAL;

				widget.getParent().currentRow = lancamento;
				widget.getParent().currentRow.__is_new = false;
				widget.getParent().dataSource.data[parentCurrentRowIndex] = widget.getParent().currentRow;
				widget.getParent().view();

				widget.reload();
				widget.activate();
				ScreenService.hideLoader();
			}.bind(this), function(error) {
				ScreenService.showMessage(error.data.error);
				ScreenService.hideLoader();
			});
		}
	};

	/**
	 * Essa função tem como finalidade setar datas defaut para o filtro da tela conforme a
	 * data de processamento da filial selecionada, trocar a editabilidade do campo de
	 * almoxarifado conforme a parametrização da filial selecionada, e setar o nome e
	 * código da filial logada caso o evento estiver sendo chamado no início da tela.
	 * Depois chama a função para validar a regra dos campos de data.
	 *
	 * @param widget | widget do filtro
	 * @param array | recebe um array com código e nome da filial selecionada no filtro
	 * @param filial | codigo da filial para saber se seta ou não o campo de filial no filtro
	 */
	this.setCampos = function(widget, array, filial) {
		//Setando datas do campo Data
		var dtprocessa = Est11000_EntradaEstoque_Service.getDtprocessa();
		var dtinicial = moment(dtprocessa, 'DD/MM/YYYY').startOf('month').format('DD/MM/YYYY');
		widget.currentRow.DTINICIAL = dtinicial;
		widget.currentRow.DTFINAL = dtprocessa;

		if (!widget.currentRow.INTERVALO) {
			widget.currentRow.INTERVALO = {};
		}
		widget.currentRow.INTERVALO.start = dtinicial;
		widget.currentRow.INTERVALO.end = dtprocessa;

		//Habilitando Almoxarifado, reseta a currentRow e desabilita Localização
		if (Est11000_EntradaEstoque_Service.utilizaAlmoraifado()) {
			widget.getField('DSLOCALESTOQ').readOnly = false;
			widget.currentRow.CDLOCALESTOQ = null;
			widget.currentRow.DSLOCALESTOQ = null;
			widget.getField('DSALMOXARIFE').readOnly = false;
			widget.currentRow.CDALMOXARIFE = null;
			widget.currentRow.DSALMOXARIFE = null;
			widget.getField('DSALMOXARIFE').reload();
		}
		else {
			widget.getField('DSLOCALESTOQ').readOnly = true;
			widget.currentRow.CDLOCALESTOQ = null;
			widget.currentRow.DSLOCALESTOQ = null;
			widget.getField('DSALMOXARIFE').readOnly = true;
			widget.currentRow.CDALMOXARIFE = null;
			widget.currentRow.DSALMOXARIFE = null;
		}
		//Setando campo de filial se for no início da tela
		if (filial === 'FILIAL_LOGADA') {
			widget.currentRow.CDFILIAL = array.CDFILIAL;
			widget.currentRow.NMFILIAL = array.NMFILIAL;
		}
		this.setMinMaxAndRequired(widget);
	};

	this.intervaloChange = function(field) {
		let widget = field.widget;
		widget.currentRow.DTINICIAL = widget.currentRow.INTERVALO.start;
		widget.currentRow.DTFINAL = widget.currentRow.INTERVALO.end;
	};

	/**
	 * Essa função tem como finalidade setar o código da filial que será inserida na retirada
	 * na row do novo item a ser inserido naquela retirada.
	 *
	 * @param widget | widget itens da retirada
	 */
	this.setCdfilimovi = function(widget) {
		let widgetTabbed = widget.container.getWidget('entradaTabbed');
		var newRow = widget.currentRow;
		newRow.CDFILIMOVI = widgetTabbed.currentRow.CDFILIMOVI;
		newRow.DTLANCMOVI = widgetTabbed.currentRow.DTLANCESTQ;
	};

	/**
	 * Essa função tem como finalidade setar a filial e a data de lançamento quando é
	 * acionado o botão de adicionar uma retirada. É sugerida a filial que foi passada
	 * no filtro, e a data de lançamento é a data de processamento da filial. Depois
	 * chama uma função para desabilitar a aba de produtos, e outra para trocar a label
	 * do botão inferior direito da tela.
	 *
	 * @param widget | widget de retirada
	 */
	this.setCurrentRowNew = function(widget) {
		widget.currentRow.CDFILIAL = getLocalVar('CDFILIAL');
		widget.currentRow.CDFILILANC = widget.appliedFilter.FILTER_ROW.CDFILIAL;
		widget.currentRow.CDFILIMOVI = widget.appliedFilter.FILTER_ROW.CDFILIAL;
		widget.currentRow.NMFILIAL = widget.appliedFilter.FILTER_ROW.NMFILIAL;
		widget.currentRow.DTLANCESTQ = Est11000_EntradaEstoque_Service.getDtprocessa();

		//this.enabledWidget(false);
		//this.changeHideInconLabelVisible(widget.actions, "Adicionar Produtos", true, "salvar", true);
	};

	/**
	 * Essa função tem a finalidade de pegar os dois campos de data do filtro, e caso o
	 * valor deles seja null, em ambos, tira sua obrigatoriedade. Caso um deles tenha
	 * valor, é setado o max e min date de cada um com o valor do outro campo e ambos
	 * são colocados como obrigatórios. Dessa forma se um deles estiver com valor, ambos
	 * serão obrigatórios, mas se o usuário não quiser filtrar por data, e deixar ambos
	 * vazios, eles deixam de ser obrigatórios.
	 *
	 * @param widget | widget do filtro
	 */
	this.setMinMaxAndRequired = function(widget) {
		var fdateIni = widget.getField('DTINICIAL');
		var fdateFin = widget.getField('DTFINAL');

		if (!fdateIni.value() && !fdateFin.value()) {
			delete fdateIni.filterProperties.validations.required;
			delete fdateFin.filterProperties.validations.required;
		}
		else {
			fdateIni.filterProperties = { "validations": {} };
			fdateIni.filterProperties.maxDate = fdateFin.value();
			fdateIni.filterProperties.validations.required = true;

			fdateFin.filterProperties = { "validations": {} };
			fdateFin.filterProperties.minDate = fdateIni.value();
			fdateFin.filterProperties.validations.required = true;
		}
	};

	/**
	 * Essa função tem a finalidade de setar o campo de Valor Unitário do produto que foi selecionado
	 * na widget de itens. Para pegar esse valor é necessario exeutar uma função do banco de dados.
	 * O resultado da função é o valor unitário do produto e sua quantidade em estoque. Ambos os valores
	 * são colocados na currentRow da widget.
	 *
	 * @param widget | widget de itens
	 */
	this.setValorUnitario = function(widget) {
		var deffer = ZHPromise.defer();
		Est11000_EntradaEstoque_Service.getCdtipocusto(widget.currentRow.CDFILIAL).then(function(cdtipocusto) {
			widget.currentRow.DTLANCMOVI = widget.getParent().currentRow.DTLANCESTQ;
			Est11000_EntradaEstoque_Service.setBlankLocalEstFields(widget);
			ValidacoesEstoque_Service.consultaCustoQuantidadeProduto(
				widget.currentRow.CDFILIAL,
				widget.currentRow.CDPRODUTO,
				widget.currentRow.DTLANCMOVI.substr(0, 10),
				cdtipocusto,
				widget.currentRow.CDALMOXARIFE,
				widget.currentRow.CDLOCALESTOQ,
				widget.currentRow.NRLOTEESTQ,
				widget.currentRow.NRSUBLOTE
			).then(function(success) {
				var consulta = success.dataset.consultaCustoQuantidadeProduto;
				widget.currentRow.QTESTOQDIA = consulta.QTESTOQDIA;
				widget.currentRow.VRUNILANCTO = consulta.VRCUSTOPROD;
				Est11000_EntradaEstoque_Service.setVrTotLancto(widget.currentRow);
				Est11000_EntradaEstoque_Service.setVrlanctoest(widget.currentRow);
				widget.currentRow.COMPLETO = 'S';
				deffer.resolve();
			}, function(error) {
				ScreenService.showMessage(error.data.error);
				deffer.reject();
			});
		}, function(error) {
			ScreenService.showMessage(error.data.error);
			deffer.reject();
		});
		return deffer;
	};

	/**
	 * Essa função tem a finalidade de mudar a data de lançamento durante a inserção
	 * de uma nova retirada. É verificada a data de processamento da filial que o
	 * usuário selecionou.
	 *
	 * @param widget | widget de retirada, no modo de inserção (swipe)
	 */
	this.suggestDtprocessa = function(widget) {
		var cdfilial = widget.currentRow.CDFILIAL;
		Est11000_EntradaEstoque_Service.getParamFilial(cdfilial, false).then(function(succes) {
			if (typeof succes === 'string') {
				ScreenService.showMessage(succes);
			}
			else {
				widget.currentRow.DTLANCESTQ = succes.DTPROCESSA;
				this.filialctrlestoq = succes.IDCTRLESTQ;
				idutilalmox = succes.IDUTILALMOX;
				idutillcestq = succes.IDUTILLCESTQ;
				idutillote = succes.IDUTILLOTE;
			}
		}, function(error) {
			ScreenService.showMessage(error.data.error);
		});
	};

	this.loadDataSource = function(widget) {
		widget.getField('DSALMOXARIFE').dataSourceFilter.forEach(function(fil) {
			if (fil.name === 'CDFILIAL') {
				fil.value = widget.currentRow.CDFILIMOVI;
			}
		});

		widget.getField('DSLOCALESTOQ').dataSourceFilter.forEach(function(fil) {
			if (fil.name === 'CDFILIAL') {
				fil.value = widget.currentRow.CDFILIMOVI;
			}
		});

		widget.getField('DSALMOXARIFE').reload();
		widget.getField('DSLOCALESTOQ').reload();
	};

	this.actViewStockVisibility = function(args) {
		let widget = {};
		if (args.owner.container)
			widget = args.owner.container.getWidget('itens');
		else
			widget = args.owner.field.widget;
		if (widget.currentRow.CDPRODUTO)
			widget.getAction('viewstock').isVisible = true;
		else
			widget.getAction('viewstock').isVisible = false;
	};

	var isset = (accessor) => {
		try {
			// Note we're seeing if the returned value of our function is not
			// undefined
			return typeof accessor() !== 'undefined' && accessor() !== null;
		}
		catch (e) {
			// And we're able to catch the Error it would normally throw for
			// referencing a property of undefined
			return false;
		}
	};

	this.detailSwitchTemplate = function(widget) {
		if ((widget.template != "widget/form.html") && (widget.template != "widget/form-view.html") && (widget.template != "widget/master_detail/grid.html")) return false;

		if (!widget.templateToForm) widget.templateToForm = "widget/form.html";
		if (!widget.templateToView) widget.templateToView = "widget/form-view.html";

		if (widget.template == widget.templateToForm) widget.template = widget.templateToView;
		else if (widget.template == widget.templateToView) widget.template = widget.templateToForm;

		templateManager.updateTemplate();

		return true;
	};

	this.manipulaScope = function(args) {
		console.log('break aqui');
	};

	this.activateWidgetTabbed = function(args) {
		let widgetPrincipal = args.owner;
		let widgetTabbed = widgetPrincipal.container.getWidget('entradaTabbed');
		let widgetGridProdutos = widgetPrincipal.container.getWidget('itens');
		let widgetToEdit = widgetPrincipal.container.getWidget('wid_toEdit');

		let row = widgetPrincipal.currentRow;
		let fieldDescricao = widgetTabbed.getField('DSLANCESTQ');


		if (row.NRNOTAFISC || row.NRLANESTENTR)
			fieldDescricao.readOnly = true;
		else
			fieldDescricao.readOnly = false;

		widgetTabbed.redraw();
		templateManager.updateTemplate();

		widgetTabbed.currentRow = widgetPrincipal.currentRow;
		widgetPrincipal.container.getWidget('entrada').activate().then(() => {
			widgetPrincipal.container.getWidget('entradaTabbed').activate();
			widgetGridProdutos.reload();
		});
	};

	this.saveGridProduto = function(args) {
		var promFirstSave = ZHPromise.defer();
		
		let widgetGridPrincipal = templateManager.container.getWidget('entrada');
		let widgetItens = templateManager.container.getWidget('itens');
		let widgetTabbed = templateManager.container.getWidget('entradaTabbed');
		let widgetFakeToEdit = templateManager.container.getWidget('wid_toEdit');

		if (widgetTabbed.currentRow.changed || widgetTabbed.currentRow.__is_new || widgetItens.currentRow.__is_new || widgetItens.currentRow.changed) {
			widgetItens.dataSource.data.forEach(row=>{
				row.CDFILIAL = widgetTabbed.currentRow.CDFILIAL;
				row.IDUTILALMOX = idutilalmox;
				row.IDUTILLCESTQ = idutillcestq;
				row.IDUTILLOTE = idutillote;	
			});
			widgetItens.currentRow.LANCAMENTO = widgetTabbed.currentRow;
			widgetTabbed.currentRow.CDTIPOOPER = cdtpoper;
			widgetTabbed.currentRow.IDENTRSAIDOP = identrsaidop;
			if (widgetTabbed.currentRow.CDFILIMOVI) {
				EstUtil.saveCrud(widgetItens, false, 'list').then(saved => {
					let nrlancto = saved.dataset.columnsToReturn[0].NRLANCESTQ;
					widgetTabbed.currentRow.__is_new = false;
					widgetTabbed.currentRow.changed = false;
					widgetItens.currentRow.__is_new = false;
					widgetItens.currentRow.changed = false;

					widgetTabbed.currentRow.NRLANCESTQ = nrlancto;
					widgetTabbed.currentRow.NRORG = getLocalVar("NRORG");
					
					widgetItens.dataSource.data.forEach(row => {
						row.__is_new = false;
						row.changed = false;
						row.NRLANCESTQ = nrlancto;
						row.NRORG = getLocalVar("NRORG");
					});
					widgetItens.reload();
					datasetBkp = [];
					this.saveActionVisibility(null);
				});
			}
			else {
				ScreenService.showMessage('Filial de movimentação não informada, favor selecionar novamente no filtro.');
			}
		}
	};

	this.fakeEditMode = function(args) {
		let fakeWidget = templateManager.container.getWidget('wid_toEdit');
		if (fakeWidget.mode != 'edit')
			fakeWidget.edit();
	};

	this.saveActionVisibility = function(args) {
		let widgetGrid = templateManager.container.getWidget('itens');
		let widgetTabbed = templateManager.container.getWidget('entradaTabbed');
		let newProduct = widgetGrid.dataSource.data.some(row => row.__is_new);

		if ((widgetGrid.dataSource.data.some(row => row.__is_new || row.changed) || widgetTabbed.currentRow.changed) && widgetGrid.dataSource.data.length > 0)
			widgetGrid.getAction('salvarLanc').isVisible = true;
		else
			widgetGrid.getAction('salvarLanc').isVisible = false;
	};

	var validaLançamentoDeIntegracaoes = function(row, args) {
		let boolBloquear = false;
		if (row.NRNOTAFISC) {
			ScreenService.showMessage('Operação Bloqueada. Lançamento Proveniente de Nota Fiscal!');
			boolBloquear = true;
		}
		if (row.NRLANESTENTR) {
			ScreenService.showMessage('Operação Bloqueada. Lançamento Proveniente de Integração!');
			boolBloquear = true;
		}
		if (row.NRORDPROD) {
			ScreenService.showMessage('Operação Bloqueada. Lançamento Proveniente de Ordem de Produção (OP)!');
			boolBloquear = true;
		}
		return boolBloquear;
	};

	this.saveItemValidation = function(args) {
		let widgetGrid = templateManager.container.getWidget('itens');
		let widgetTabbed = templateManager.container.getWidget('entradaTabbed');

		widgetTabbed.currentRow.DTLANCESTQ = widgetTabbed.currentRow.DTLANCESTQ.substr(0, 10);
		if (widgetTabbed.currentRow.DTEMISSAO)
			widgetTabbed.currentRow.DTEMISSAO = widgetTabbed.currentRow.DTEMISSAO.substr(0, 10);

		if (widgetGrid.currentRow.QTTOTLANCTO == 0)
			ScreenService.showMessage('Quantidade deve ser informada.');
		else if (widgetGrid.currentRow.VRUNILANCTO == 0)
			ScreenService.showMessage('Valor unitário deve ser maior que zero.');
		else if (!widgetGrid.currentRow.NMPRODUTO)
			ScreenService.showMessage('Produto deve ser informado.');
		else {
			ScreenService.goBack();
			datasetBkp.push(widgetGrid.currentRow);
			this.saveActionVisibility(args);
		}
	};

	this.newLanctoEntrada = function(widgetEntrada) {
		datasetBkp = [];
		if (EstUtil.onValidateFilterRequirement(widgetEntrada, true)) return;

		let widgetTabbed = templateManager.container.getWidget('entradaTabbed');
		widgetEntrada.currentRow.CDFILIMOVI = widgetEntrada.appliedFilter.FILTER_ROW.CDFILIMOVI;
		widgetTabbed.currentRow.CDFILIMOVI = widgetEntrada.appliedFilter.FILTER_ROW.CDFILIMOVI;
		widgetTabbed.currentRow.CDTIPOOPER = cdtpoper;
		widgetTabbed.currentRow.IDENTRSAIDOP = identrsaidop;
	};

	this.clearProductsOldData = function(args) {
		let widgetProdutos = templateManager.container.getWidget('itens');
		widgetProdutos.dataSource.data = [];
	};

}
Configuration(function(ContextRegister) {
	ContextRegister.register('Est11000_EntradaEstoque_Controller', Est11000_EntradaEstoque_Controller);
});
